;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

ShowInstDetails show
CRCCheck on

SetDatablockOptimize on
SetOverwrite on

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  Name "  . "
  OutFile "Setup.exe"
  InstallDir "$PROGRAMFILES\phones_volgorechensk"
  

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "license_phones.txt"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES

  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH

  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "Russian"

;--------------------------------
;Installer Sections


Section "TCB"

SetOutPath "$INSTDIR"
	File "index.htm"
	File "kgres.htm"
	File "vrtz.htm"
	File "up.gif"
  
	WriteUninstaller "$INSTDIR\ .exe"
	CreateShortCut "$DESKTOP\  . .lnk" "$INSTDIR\index.htm" '"$INSTDIR\index.htm" /CD'
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\  . " "DisplayName" "  . "
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\  . " "UninstallString" '"$INSTDIR\ .exe"'

ExecShell "open" '"$INSTDIR\index.htm"'
SectionEnd


;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  Delete "$INSTDIR\*.*"
  RMDir "$INSTDIR"


DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\  . "
Delete "$DESKTOP\  . .lnk"


SectionEnd