;!define MUI_PRODUCT ""
;!define MUI_VERSION "v2.601"
;!include "MUI.nsh"

ShowInstDetails nevershow
CRCCheck on
SetDatablockOptimize on
SetOverwrite on

InstType ""

OutFile "Setup.exe"
InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"

!define MUI_CUSTOMPAGECOMMANDS
!define MUI_LICENSEPAGE
!define MUI_COMPONENTSPAGE
!define MUI_DIRECTORYPAGE
!define MUI_ABORTWARNING
!define MUI_UNINSTALLER
!define MUI_UNCONFIRMPAGE

!insertmacro MUI_SYSTEM
!insertmacro MUI_LANGUAGE "Russian"
LicenseData "LicenseVIS.txt"
!insertmacro MUI_PAGECOMMAND_LICENSE
!insertmacro MUI_PAGECOMMAND_COMPONENTS
!insertmacro MUI_PAGECOMMAND_DIRECTORY
!insertmacro MUI_PAGECOMMAND_INSTFILES

!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

Section ""
SectionIn 1 2 3 RO
Call .GetWindowsVersion

Delete "$INSTDIR\Data\Addition_Gfx\*.*"
Delete "$INSTDIR\Data\Addition_Text\*.*"
Delete "$INSTDIR\Data\*.*"
Delete "$INSTDIR\*.*"

DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\"
Delete "$SMPROGRAMS\\*.*"
RMDir "$SMPROGRAMS\"
Delete "$DESKTOP\.lnk"


;Good1:
SetOutPath $INSTDIR
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\" "DisplayName" ""
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\" "UninstallString" '"$INSTDIR\ .exe"'

File "VIS\.exe"
File "VIS\.exe.manifest"
File "VIS\.htm"
File "VIS\ .htm"
SetOutPath $INSTDIR\Data
File "VIS\Data\Tips.txt"
File "VIS\Data\Index.css"
File "VIS\Data\Index_help.css"
File "VIS\Data\Bus.htm"
File "VIS\Data\PhonesHome.txt"
File "VIS\Data\PhonesOAO.txt"
File "VIS\Data\PhonesKGRES.txt"
File "VIS\Data\PhonesVrTZ.txt"
File "VIS\Data\Categories.txt"
File "VIS\Data\Dial.htm"
File "VIS\Data\Streets.txt"
File "VIS\Data\Others.htm"
File "VIS\Data\Map.txt"
File "VIS\Data\Map.emf"
File "VIS\Data\String.ini"
SetOutPath $INSTDIR\Data\Addition_Text
File "VIS\Data\Addition_Text\*.*"

;SetOutPath $INSTDIR\Data\Addition_GFX
;File "VIS\Data\Addition_GFX\*.*"

SetOutPath $INSTDIR\Data\Main_Gfx
File "VIS\Data\Main_GFX\*.*"

SetOutPath $INSTDIR

CreateShortCut "$DESKTOP\.lnk" "$INSTDIR\.exe" '"$INSTDIR\.exe" /CD'
CreateDirectory "$SMPROGRAMS\"
CreateShortCut "$SMPROGRAMS\\.lnk" "$INSTDIR\.exe"
CreateShortCut "$SMPROGRAMS\\.lnk" "$INSTDIR\.htm"
WriteUninstaller " .exe"
CreateShortCut "$SMPROGRAMS\\ .lnk" "$INSTDIR\ .exe"

ExecShell "open" '"$INSTDIR"'
SetAutoClose true
SectionEnd


Section "Uninstall"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\"
Delete "$INSTDIR\Data\Addition_Gfx\*.*"
RMDir "$INSTDIR\Data\Addition_Gfx"

Delete "$INSTDIR\Data\Addition_Text\*.*"
RMDir "$INSTDIR\Data\Addition_Text"

Delete "$INSTDIR\Data\Main_Gfx\*.*"
RMDir "$INSTDIR\Data\Main_Gfx"

Delete "$INSTDIR\Data\*.*"
RMDir "$INSTDIR\Data"
Delete "$INSTDIR\*.*"
RMDir "$INSTDIR"
Delete "$SMPROGRAMS\\*.*"
RMDir "$SMPROGRAMS\"
Delete "$DESKTOP\.lnk"
MessageBox MB_YESNO "        ?" IDYES NoAbort
		Delete "$WINDIR\VIS.ini"
		Delete "$WINDIR\VIS_Book.txt"
NoAbort:
IfFileExists "$INSTDIR" 0 NoErrorMsg
MessageBox MB_OK ":     '$INSTDIR' !" IDOK 0 ; skipped if file doesn't exist
goto Exit
NoErrorMsg:
HideWindow 
SetAutoClose true
Exit:

SectionEnd


Function .GetWindowsVersion
  ReadRegStr $0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber
  StrCpy $9 $0 3
  StrCmp $9 '4.0' lbl_win32_95
  Goto lbl_done
lbl_win32_95:
  StrCpy $0 '95'
  MessageBox MB_OK|MB_ICONSTOP ":  Windows 98  ."
  Quit
  Goto lbl_done
lbl_done:

FunctionEnd


SubSection " " SectionSprav
Section "  " SectionCity
SectionIn 1
SetOutPath $INSTDIR\Data
File "VIS\Data\CityCodes.txt"
File "VIS\Data\KostromaCodes.txt"
File "VIS\Data\OldCities.txt"
SetOutPath $INSTDIR
SectionEnd

Section "  " SectionCountry
SectionIn 1
SetOutPath $INSTDIR\Data
File "VIS\Data\CountryCodes.txt"
SetOutPath $INSTDIR
SectionEnd

Section " " SectionMobile
SectionIn 1
SetOutPath $INSTDIR\Data
File "VIS\Data\MobileCodes.txt"
SetOutPath $INSTDIR
SectionEnd

Section " " SectionPost
SectionIn 1
SetOutPath $INSTDIR\Data
File "VIS\Data\PostIndexes.txt"
SetOutPath $INSTDIR
SectionEnd

Section "  " SectionAuto
SectionIn 1
SetOutPath $INSTDIR\Data
File "VIS\Data\Regions.txt"
SetOutPath $INSTDIR
SectionEnd
SubSectionEnd


;Section "    ()" SectionGFX
;SectionIn 1 2 3 RO

;SetOutPath $INSTDIR\Data\Addition_GFX
;File "VIS\Data\Addition_GFX\*.*"
;SetOutPath $INSTDIR

;SectionEnd

