#ifndef MainH
#define MainH

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
#include "Unit6.h"
#include "Unit7.h"
#include "Unit83.h"
#include "Unit9.h"
#include "Unit10.h"
#include "Unit15.h"
#include "Unit13.h"
#include "Unit14.h"
#include "Unit16.h"
#include "Unit17.h"
#include "Unit18.h"
#include "Unit19.h"
#include "Unit20.h"
#include "Unit81.h"
#include "Unit8.h"
#include <Tapi.h>
#include <vcl.h>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Messages.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include <jpeg.hpp>
#include <AppEvnts.hpp>
#include <BandActn.hpp>
#include "Defines.h"

enum    {FORM_HOME, FORM_DIAL, FORM_BUS, FORM_BOOK, FORM_OAO, FORM_MAP, FORM_REGIONS, FORM_CODES, FORM_ICODES, FORM_OTHERS, FORM_POST, FORM_MOBILE, FORM_HISTORY, FORM_BANNER};
enum    {TOOLBUTTONS, PANELTITLE};

struct TPrefs
{
bool bWinMax;
int iWinX;
int iWinY;

bool bTips;
int iPerehodAtMap;
bool bAutoSearch;
int iWhereComputer;
bool bNoIconsMenu;
bool bNoTitle;
bool bSmallIcons;
bool bNoLine;
bool bShemaClosed;
bool bNavodka;
bool bTitul;
bool bSeeAllSaves;
bool bSelectionText;
bool bHil;
bool bSaveText;
bool bMoveMousePhoto;
bool bMoveMousePlan;
bool bPhotoProportional;
bool bPhoto;
bool bPhotoOff;
bool bTextEffect;
bool bToolBarFirst;
bool bBreak;
bool bPhotoWarning;

int iPhotoX;
int iPhotoY;
int iPhotoW;
int iPhotoH;

char szHome1[MAX_LEN_STRING];
char szHome2[MAX_LEN_STRING];
char szHome3[MAX_LEN_STRING];
char szHome4[MAX_LEN_STRING];
char szHome5[MAX_LEN_STRING];

char szCity[MAX_LEN_STRING];
char szCountry[MAX_LEN_STRING];
char szPost[MAX_LEN_STRING];
char szMobile[MAX_LEN_STRING];
char szOAO[MAX_LEN_STRING];
char szOAOPhone[MAX_LEN_STRING];

int iOAON;
int iOAOCatN;
int iMapN;
int iRegionN;
};
//------------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu1;
        TMenuItem *NProject;
        TMenuItem *NWindow;
        TMenuItem *NHelp;
        TMenuItem *NQuit;
        TMenuItem *NWindowCascade;
        TMenuItem *NWindowTileRight;
        TMenuItem *NWindowMinimize;
        TStatusBar *StatusBar;
        TMenuItem *NWindowTileDown;
        TMenuItem *NAboutProg;
        TMenuItem *NHomePhones;
        TMenuItem *NDial;
        TMenuItem *NBus;
        TMenuItem *NBook;
        TMenuItem *NSpravka;
        TMenuItem *N8;
        TMenuItem *NOAOPhones;
        TMenuItem *N14;
        TMenuItem *NMap;
        TMenuItem *N11;
        TMenuItem *NRegions;
        TMenuItem *NCountryCodes;
        TMenuItem *NCityCodes;
        TMenuItem *NOthers;
        TMenuItem *NTips;
        TActionList *ActionList1;
        TWindowMinimizeAll *WindowMinimizeAll1;
        TWindowTileHorizontal *WindowTileHorizontal1;
        TWindowTileVertical *WindowTileVertical1;
        TWindowCascade *WindowCascade1;
        TMenuItem *NVisInInet;
        TMenuItem *NPrefs;
        TMenuItem *NPost;
        TMenuItem *NSearchPhone;
        TMenuItem *NWriteLetters;
        TMenuItem *N2;
        TToolBar *ToolBar1;
        TToolButton *ToolButtonHomePhones;
        TToolButton *ToolButtonOAOPhones;
        TToolButton *ToolButtonSearchPhone;
        TToolButton *ToolButtonDial;
        TToolButton *ToolButtonCityCodes;
        TToolButton *ToolButtonCountryCodes;
        TToolButton *ToolButtonPost;
        TToolButton *ToolButtonRegions;
        TToolButton *ToolButtonMap;
        TToolButton *ToolButtonBus;
        TToolButton *ToolButtonOthers;
        TToolButton *ToolButtonBook;
        TImageList *ImageList2;
        TToolButton *ToolButtonMobileCodes;
        TMenuItem *NMobileCodes;
        TImageList *ImageList1;
        TToolButton *ToolButton1;
        TMenuItem *N1;
        TToolButton *ToolButton2;
        TMenuItem *N3;
        TMenuItem *NSeePhoto;
        TMenuItem *N5;
        TPopupMenu *PopupMenu1;
        TMenuItem *NSmallIcons;
        TMenuItem *N6;
        TMenuItem *NButtons;
        TImageList *ImageList3;
        TPanel *PanelTitle;
        TCoolBar *CoolBar1;
        TTimer *Timer2;
        TMenuItem *NTitle;
        TMenuItem *NTextEffect;
        TMenuItem *NLine;
        TSplitter *Splitter1;
        TToolButton *ToolButtonBanner;
        TMenuItem *NBanner;
        void __fastcall FileNew1Execute(TObject *Sender);
        void __fastcall FileExit1Execute(TObject *Sender);
        void __fastcall ToolButtonDialClick(TObject *Sender);
        void __fastcall ToolButtonBusClick(TObject *Sender);
        void __fastcall ToolButtonBookClick(TObject *Sender);
        void __fastcall NSpravkaClick(TObject *Sender);
        void __fastcall ToolButtonMapClick(TObject *Sender);
        void __fastcall ToolButtonOAOPhonesClick(TObject *Sender);
        void __fastcall ToolButtonRegionsClick(TObject *Sender);
        void __fastcall ToolButtonCityCodesClick(TObject *Sender);
        void __fastcall ToolButtonCountryCodesClick(TObject *Sender);
        void __fastcall ToolButtonOthersClick(TObject *Sender);
        void __fastcall NTipsClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall NAboutProgClick(TObject *Sender);
        void __fastcall NVisInInetClick(TObject *Sender);
        void __fastcall NPrefsClick(TObject *Sender);
        void __fastcall ToolButtonSearchPhoneClick(TObject *Sender);
        void __fastcall ToolButtonPostClick(TObject *Sender);
        void __fastcall NWriteLettersClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall ToolButtonMobileCodesClick(TObject *Sender);
        void __fastcall NSeePhotoClick(TObject *Sender);
        void __fastcall NButtonsClick(TObject *Sender);
        void __fastcall NSmallIconsClick(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall NTitleClick(TObject *Sender);
        void __fastcall NLineClick(TObject *Sender);
        void __fastcall NTextEffectClick(TObject *Sender);
        void __fastcall ToolButtonBannerClick(TObject *Sender);
        void __fastcall NBannerClick(TObject *Sender);
public:
	virtual __fastcall TMainForm(TComponent *Owner);

        AnsiString aVer;
        AnsiString aBufIniDir;
        HMODULE hShell32;
        char cVersion[MAX_LEN_STRING];
        char cInet[MAX_LEN_STRING];
        char cShortInet[MAX_LEN_STRING];
        char cMail[MAX_LEN_STRING];
        char cShortMail[MAX_LEN_STRING];
        char cTitle[MAX_LEN_STRING];
        char cTitle1[MAX_LEN_STRING];
        char cTitle2[MAX_LEN_STRING];
        char cDate[MAX_LEN_STRING];

        bool bNoMessageHelp;
        bool bErrorToolBar;
        bool bErrorToolBarBook;
        bool bErrorSmallIcons;
        bool bErrorBigIcons;


        bool bFormBus;
        bool bFormBanner;
        bool bFormMap;
        bool bFormHomePhones;
        bool bFormOAOPhones;
        bool bFormBook;
        bool bFormDial;
        bool bFormCityCodes;
        bool bFormCountryCodes;
        bool bFormRegions;
        bool bFormOthers;
        bool bFormPost;
        bool bFormOboz;
        bool bFormLogo;
        bool bFormMobileCodes;
        bool bFormHistory;
        bool bRunHomePhones;
        bool bRunOAOPhones;

        bool bHome;
        bool bOAO;
        bool bKGRES;
        bool bVRTZ;
        bool bCityCodes;
        bool bCountryCodes;
        bool bMobileCodes;
        bool bPost;


        TPrefs Prefs;

        void LoadINIFile();
        void LoadINIString();
        void SaveINIFile ();
        void MessageHelp(int);
        void ShowAbonentAndMap(int);
        void CopyAt(void *, bool, void*);
        void NumToStringGrid(void *, int);
        void CallDialer(AnsiString, AnsiString);
        void ResizeStringGrid(void*, void*);
        void LoadInetAdr(void* , char*);
        void SortStringGrid(void* ,int ,int);
        void SortArrayA(void* ,void* ,int ,int);
        bool PathFileExists1(char* cFile);
        void SeeTitle(int iForm);
        void EnableBar(int iWindow, bool bEnabled);
//         
        AnsiString aFileName;
        bool bChangeText;
};
//------------------------------------------------------------------------------
extern TMainForm *MainForm;
//------------------------------------------------------------------------------
#endif
