#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit1.h"
#include "Main.h"
#include "Unit83.h"
#include "CSV.cpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

#define KOEF_FOR_SHAPE          30
#define LUPE_MIN                0.5
#define LUPE_MAX                7
#define LUPE_DELTA              0.5

//------------------------------------------------------------------------------
enum {LUPE_PLUS, LUPE_MINUS, LUPE_STOP};

static int iLoopForShape=9;
const int crMyCursor = 5;
TFormMap *FormMap;
int x_tran=900,y_tran, x_org, y_org;
bool bNext=true, bStart=false;
bool bDoubleClick=false;
int x, y;
AnsiString AnsiStreet="";
AnsiString AnsiHouse="";
AnsiString AnsiOAO="";
AnsiString AnsiCopy="";

TCSVBase Map=TCSVBase(FILENAME_MAP, 6);
//------------------------------------------------------------------------------
void TFormMap::PrefsForMinComputer()
{
if (!MainForm->Prefs.bSeeAllSaves && MainForm->Prefs.bSelectionText && MainForm->Prefs.bNavodka && !MainForm->Prefs.bAutoSearch && !MainForm->Prefs.bMoveMousePhoto && !MainForm->Prefs.bMoveMousePlan)
        {
        ImageMap->Cursor=crDefault;
        MainForm->Prefs.bHil=true;
        ScrollBox1->HorzScrollBar->Tracking=false;
        ScrollBox1->VertScrollBar->Tracking=false;
        }
else
        {
        ImageMap->Cursor=crHandPoint;
        ScrollBox1->HorzScrollBar->Tracking=true;
        ScrollBox1->VertScrollBar->Tracking=true;
        MainForm->Prefs.bHil=false;
        }
}
//------------------------------------------------------------------------------
__fastcall TFormMap::TFormMap(TComponent* Owner)
        : TForm(Owner)
{
MainForm->bFormMap=true;
try
        {
        ImageMap->Picture->LoadFromFile(FILENAME_MAP_PICTURE);
        }
catch (...)
        {
        MainForm->ToolButtonMap->Visible=false;
        MainForm->NMap->Visible=false;
        MainForm->bFormMap=false;
        MainForm->Prefs.iPerehodAtMap=3;
        Close();
        return;
        }

x_org=ImageMap->Picture->Width;
y_org=ImageMap->Picture->Height;
dKoef=x_org/y_org;
y_tran=x_tran/dKoef;

if (Map.bError)
        {
        MainForm->Prefs.iPerehodAtMap=3;
        MainForm->ToolButtonMap->Visible=false;
        MainForm->NMap->Visible=false;
        MainForm->bFormMap=false;
        Close();
        return;
        }

AnsiString an1="";
AnsiString an2="";

static bool bStart=true;
if (bStart) Map.FindForTreeInit();
bStart=false;

int iNext=0;
iStreets=0;
TTreeNode *Node;
for (int i=0;i<Map.iAbonentsMap;i++)
        {
        an2=Map.lpArray[i][0];
        if (an2!=an1)
                {
                iNext++;
                iStreets++;
                Node=TreeViewStreets->Items->Add(NULL, Map.lpArray[i][0]);
                an1=Map.lpArray[i][0];
                }
        if (iNext<0) break;
        if (*(Map.lpArray[i][1])!='#' && *(Map.lpArray[i][1])) TreeViewStreets->Items->AddChild(Node, Map.lpArray[i][1]);
        }

iNext=0;
for (int i=Map.iAbonentsMap;i<Map.iAbonentsMap+Map.iAbonentsMapOAO;i++)
        {
        an2=Map.lpArray[i][0];
        if (an2!=an1)
                {
                iNext++;
                if (*(Map.lpArray[i][1])!='#')
                        {
                        if (!*Map.lpArray[i][0])        Node=TreeViewObjects->Items->Add(NULL, Map.lpArray[i][1]);
                        else
                                {
                                Node=TreeViewObjects->Items->Add(NULL, Map.lpArray[i][0]);
                                an1=Map.lpArray[i][0];
                                }
                        }
                }
        if (iNext<0) break;
        if (*(Map.lpArray[i][1])!='#' && *(Map.lpArray[i][0])) TreeViewObjects->Items->AddChild(Node, Map.lpArray[i][1]);
        }
iPointMainX=365;
iPointMainY=145;

dZoom=1.0;
ImageResize();
Screen->Cursors[crMyCursor] = LoadCursor(HInstance, "CURSOR1");

AnsiString Ansi=DIRNAME_ADD_TEXT;
Ansi+="main.txt";
bPanelAddClosed=false;
try
        {
        MemoAddition->Lines->LoadFromFile(Ansi.c_str());
        }
catch (...)
        {
        bPanelAddClosed=true;
        }
ScrollBox1->DoubleBuffered=true;
FormMap->DoubleBuffered=true;
//if (MainForm->Prefs.bSaveText)
//        {
        if (MainForm->Prefs.iMapN)
                {
                if (!bPanelAddClosed)    GroupBox2->Visible=true;
                else    GroupBox2->Visible=false;
                PageControl1->ActivePageIndex=1;
                }
        else
                {
                PageControl1->ActivePageIndex=0;
                }
  //      }
PrefsForMinComputer();
HowManyObjects();

Graphics::TBitmap *bm = new Graphics::TBitmap();
try
        {
        bm->LoadFromFile(FILENAME_PICTURE_STREET);
        ImageList1->AddMasked(bm, clWhite);
        bm->LoadFromFile(FILENAME_PICTURE_HOUSE);
        ImageList1->AddMasked(bm, clWhite);
        PageControl1->Images=ImageList1;
        }
catch (...)
        {
        }
delete bm;
PanelZoom->Height=32;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::LoopPlusClick(TObject *Sender)
{
LoopPlusMinus(LUPE_PLUS, 0);
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::LoopPlusMinus(int iFlag, double dLupe)
{
static double dOldLupe=-1;

if (dZoom==LUPE_MIN && iFlag==LUPE_MINUS) return;
if (dZoom==LUPE_MAX && iFlag==LUPE_PLUS) return;

if (iFlag==LUPE_PLUS) dZoom+=LUPE_DELTA;
if (iFlag==LUPE_MINUS) dZoom-=LUPE_DELTA;
if (iFlag==LUPE_STOP)
        {
        dZoom=dLupe;
        if (dLupe==dOldLupe)    return;
        }
dOldLupe=dLupe;
if (dZoom<LUPE_MIN+LUPE_DELTA)
        {
        dZoom=LUPE_MIN;
        LoopMinus->Enabled=false;
        NDecMap->Enabled=false;
        LoopPlus->Enabled=true;
        NIncMap->Enabled=true;
        }

if (dZoom>LUPE_MAX-LUPE_DELTA)
        {
        LoopPlus->Enabled=false;
        NIncMap->Enabled=false;
        LoopMinus->Enabled=true;
        NDecMap->Enabled=true;
        dZoom=LUPE_MAX;
        }
if (dZoom>LUPE_MIN && dZoom<LUPE_MAX)
        {
        LoopPlus->Enabled=true;
        NIncMap->Enabled=true;
        LoopMinus->Enabled=true;
        NDecMap->Enabled=true;
        }
ImageResize();
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::LoopMinusClick(TObject *Sender)
{
LoopPlusMinus(LUPE_MINUS, 0);
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::ImageResize()
{
Timer1->Enabled=false;
ImageMap->Height=dZoom*y_tran;
ImageMap->Width=dZoom*x_tran;
ScrollBox1->HorzScrollBar->Position=0;
ScrollBox1->VertScrollBar->Position=0;
if (ScrollBox1->Width<ImageMap->Width)
        {
        ImageMap->Left=0;
        }
else    ImageMap->Left=(ScrollBox1->Width-ImageMap->Width)/2;
if (ScrollBox1->Height<ImageMap->Height)
        {
        ImageMap->Top=0;
        }
else   ImageMap->Top=(ScrollBox1->Height-ImageMap->Height)/2;
int dx=iPointMainX*dZoom-ScrollBox1->Width/2;
int dy=iPointMainY*dZoom-ScrollBox1->Height/2;
ScrollBox1->HorzScrollBar->Position=dx;
ScrollBox1->VertScrollBar->Position=dy;
Shape1->Left=ImageMap->Left+iPointMainX*dZoom-Shape1->Width/2;
Shape1->Top=ImageMap->Top+iPointMainY*dZoom-Shape1->Height/2;
if (!bStart)
        {
        Shape1->Width=dZoom*2+2;
        Shape1->Height=dZoom*2+2;
        }
Timer1->Enabled=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::CenterClick(TObject *Sender)
{
LoopPlusMinus(LUPE_STOP, 2);
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::FormResize(TObject *Sender)
{
ImageResize();
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::Timer1Timer(TObject *Sender)
{
static int iTimer=4;
static int iRadius=RADIUS_SHAPE;

if ((iTimer<0 || bNext) && iLoopForShape>0)
        {
        iTimer=4;
        iLoopForShape--;
        if (!bStart)
        if (bPointStatus)
                {
                PaintShape(iPointMainX*dZoom, iPointMainY*dZoom, dZoom*2+2, clWhite);
                bPointStatus=false;
                }
        else
                {
                PaintShape(iPointMainX*dZoom, iPointMainY*dZoom, dZoom*2+2, clRed);
                bPointStatus=true;
                }
        }
iTimer--;

if (bNext)
        {
        iRadius=KOEF_FOR_SHAPE*dZoom;
        if (iRadius>100) iRadius=100;
        ScrollBox1->HorzScrollBar->Position=iPointMainX*dZoom-ScrollBox1->Width/2;
        ScrollBox1->VertScrollBar->Position=iPointMainY*dZoom-ScrollBox1->Height/2;
        }
bNext=false;

if (bStart)
        {
        PaintShape(iPointMainX*dZoom, iPointMainY*dZoom, iRadius, clRed);
        iRadius-=dZoom*3;
        if (iRadius<0)
                {
                iRadius=KOEF_FOR_SHAPE*dZoom;
                bStart=false;
                iTimer=4;
                iLoopForShape=9;
                bPointStatus=false;
                }
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->StatusBar->Font->Style=TFontStyles();
MainForm->bFormMap=false;
MainForm->ToolButtonMap->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::FormActivate(TObject *Sender)
{
MainForm->ToolButtonMap->Down=true;
MainForm->SeeTitle(FORM_MAP);
MainForm->StatusBar->Font->Style=TFontStyles()<< fsBold;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::FormMouseWheel(TObject *Sender, TShiftState Shift,
      int WheelDelta, TPoint &MousePos, bool &Handled)
{
static int iLoop=3;
if (MousePos.x>=(ScrollBox1->Left+FormMap->Left+MainForm->Left) && MousePos.x<=(ScrollBox1->Left+ScrollBox1->Width+FormMap->Left+MainForm->Left))
        {
        if (WheelDelta==120)
                {
                if (iLoop==1)
                        {
                        LoopMinus->Click();
                        iLoop=3;
                        }
                iLoop--;
                }
        else
                {
                if (iLoop==5)
                        {
                        LoopPlus->Click();
                        iLoop=3;
                        }
                iLoop++;
                }
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::TreeViewStreetsChange(TObject *Sender, TTreeNode *Node)
{
Shape1->Visible=false;
Timer1->Enabled=false;

for (int n=0;n<TreeViewStreets->Items->Count;n++)
        {
        if (Node==TreeViewStreets->Items->Item[n])
                {
                if (FindAddr(FormPhoto->Image1, Node->Text, "", ONLY_STREET))
                        {
                        if (!iPointX && !iPointY) MessageBox(MainForm->Handle, "      .", " !", MB_OK|MB_ICONWARNING);
                        else    ShowAtMap(NULL);
                        return;
                        }
                }
        else
                {
                for (int i=0; i<TreeViewStreets->Items->Item[n]->Count;i++)
                        {
                        if (Node==TreeViewStreets->Items->Item[n]->Item[i])
                                {
                                if (FindAddr(FormPhoto->Image1, TreeViewStreets->Items->Item[n]->Text, Node->Text, ALL))
                                        {
                                        ShowAtMap(NULL);
                                        return;
                                        }
                                }
                        }
                }
        }
if (FindAddr(FormPhoto->Image1, Node->Text, "", ONLY_STREET))
        {
        ShowAtMap(NULL);
        return;
        }
}
//------------------------------------------------------------------------------
bool __fastcall TFormMap::FindAddr(TImage * Image, AnsiString anStreet, AnsiString anHouse, int iFlag)
{
bool bRes=false;
AnsiString anBuf1="", anBuf2="",anBuf3="", anBuf4="";
if (iFlag==ALL)
for (int i=0; i<Map.iAbonentsMap;i++)
        {
        anBuf1=Map.lpArray[i][0];
        anBuf2=Map.lpArray[i][1];
        anBuf3=Map.lpArray[i][2];
        anBuf4=Map.lpArray[i][3];
        if (anBuf1==anStreet && anBuf2==anHouse)
                {
                bRes=true;
                iPointX=anBuf3.ToIntDef(0)*x_tran/x_org;
                iPointY=anBuf4.ToIntDef(0)*y_tran/y_org;
                if (*Map.lpArray[i][4])
                        {
                        AnsiString Ansi=DIRNAME_ADD_GFX;
                        Ansi+=Map.lpArray[i][4];
                        if (Image)
                              {
                              try
                                     {
                                     Image->Picture->LoadFromFile(Ansi);
                                     Image->Visible=true;
                                     bRes=true;
                                     }
                              catch (...)
                                     {
                                     Image->Visible=false;
                                     }

                              }
                        }
                else
                        {
                        if (Image)     Image->Visible=false;
                        }
                break;
                }
        }
else if (anHouse=="")
        {
        for (int i=0; i<Map.iAbonentsMap;i++)
                {
                anBuf1=Map.lpArray[i][0];
                anBuf2=Map.lpArray[i][1];
                anBuf3=Map.lpArray[i][2];
                anBuf4=Map.lpArray[i][3];
                if (anBuf1==anStreet)
                        {
                        bRes=true;
                        iPointX=anBuf3.ToIntDef(0)*x_tran/x_org;
                        iPointY=anBuf4.ToIntDef(0)*y_tran/y_org;
                        try
                                {
                                if (*Map.lpArray[i][4])
                                        {
                                        AnsiString Ansi=DIRNAME_ADD_GFX;
                                        Ansi+=Map.lpArray[i][4];
                                        if (Image)
                                                {
                                                Image->Picture->LoadFromFile(Ansi);
                                                Image->Visible=true;
                                                bRes=true;
                                                }
                                        }
                                else
                                        {
                                        if (Image)     Image->Visible=false;
                                        }
                                }
                        catch(...)
                                {
                                if (Image)    Image->Visible=false;
                                }
                        break;
                        }
                }
        }

if (!bRes && Image)     Image->Visible=false;

return bRes;
}
//------------------------------------------------------------------------------
void TFormMap::ShowAtMap(int iMode)
{
Timer1->Enabled=true;
Shape1->Visible=true;
static bool bFlag=true;
iPointMainX=iPointX;
iPointMainY=iPointY;

if (bFlag) LoopPlusMinus(LUPE_STOP, 3);
bFlag=false;

bNext=true;
bStart=!MainForm->Prefs.bNavodka;
if (MainForm->Prefs.bHil)       iLoopForShape=1;
else    iLoopForShape=9;
bPointStatus=false;
if (iMode)      CloseHot();
}
//------------------------------------------------------------------------------
bool TFormMap::FindNameOAO(TImage* Image, AnsiString anAbonentOAO)
{
bool bRes=false;
for (int i=Map.iAbonentsMap; i<Map.iAbonentsMap+Map.iAbonentsMapOAO;i++)
        {
        char * cBuf=Map.lpArray[i][1];
        if (*cBuf=='#') cBuf++;
        if (Map.CompareL(anAbonentOAO.c_str(), cBuf))
                {
                if (FindAddr(Image, Map.lpArray[i][2], Map.lpArray[i][3], ALL))
                        {
                        bRes=true;
                        AnsiString Ansi=DIRNAME_ADD_TEXT;
                        try
                                {
                                if (*Map.lpArray[i][4])
                                        {
                                        Ansi+=Map.lpArray[i][4];
                                        MemoAddition->Lines->LoadFromFile(Ansi);
                                        AnsiString aAnsi=anAbonentOAO;
                                        aAnsi+=':';
                                        MemoAddition->Lines->Insert(0, aAnsi.c_str());
                                        }
                                else
                                        {
                                        MemoAddition->Lines->Clear();
                                        }
                                }
                        catch(...)
                                {
                                MemoAddition->Lines->Clear();
                                }
                        }
                }
        }

if (!bRes && Image)     Image->Visible=false;

return bRes;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::TreeViewStreetsMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
TTreeNode *TreeNode;
TTreeView* TreeView=(TTreeView*)Sender;

if (TreeNode=TreeView->GetNodeAt(X, Y)) TreeView->Hint=TreeNode->Text;
else    TreeView->Hint="";
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::Panel2Resize(TObject *Sender)
{
ButtonSpot->Top=(Panel2->Height-ButtonSpot->Height)/2;
}
//------------------------------------------------------------------------------
void TFormMap::CloseHot()
{
if (Panel1->Visible)   ButtonSpot->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::N5Click(TObject *Sender)
{
ShellExecute( MainForm->Handle, "open", "Data\\Map.emf", NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::PageControl1Change(TObject *Sender)
{
if (PageControl1->ActivePage==TabSheet2 && !bPanelAddClosed)    GroupBox2->Visible=true;
else    GroupBox2->Visible=false;
}
//------------------------------------------------------------------------------

void __fastcall TFormMap::ButtonSpotClick(TObject *Sender)
{
if (Panel2->Left)
        {
        Panel1->Visible=false;
        ButtonSpot->Caption="";
        }
else
        {
        Panel1->Visible=true;
        ButtonSpot->Caption="";
        }
PanelZoom->Left=ScrollBox1->Left+7;
ImageResize();
}
//------------------------------------------------------------------------------

void __fastcall TFormMap::TreeViewObjectsChange(TObject *Sender, TTreeNode *Node)
{
Shape1->Visible=false;
Timer1->Enabled=false;

if (FindNameOAO(FormPhoto->Image1, Node->Text))        ShowAtMap(NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::ScrollBox1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
x=X;
y=Y;
static int x1=-1, y1=-1, x2=-1, y2=-1;
static double dZoom1=-1;
bool bAdrWrite=false;
bool bTwoPoint=false;

if (LabelX->Visible)
        {
        AnsiString AnsiX="X: ";
        AnsiString AnsiY="Y: ";
        AnsiString AnsiBuf=(int) (X/dZoom*x_org/x_tran);
        AnsiX+=AnsiBuf;
        AnsiCopy=AnsiBuf;
        AnsiCopy+=";";
        AnsiBuf=(int) (Y/dZoom*y_org/y_tran);
        AnsiY+=AnsiBuf;
        AnsiCopy+=AnsiBuf;
        LabelX->Caption=AnsiX;
        LabelY->Caption=AnsiY;
        }
if (!Shift.Contains(ssLeft))
        if (dZoom1!=dZoom || X<x1 || X>x2 || Y<y1 || Y>y2)
                {
                dZoom1=dZoom;
                bool bSet=false;
                for (int i=0;i<Map.iAbonentsMap;i++)
                        {
                        AnsiString Ansi1=Map.lpArray[i][2];
                        int k=Ansi1.ToIntDef(0)*x_tran/x_org;
                        x1=(k-6)*dZoom;
                        x2=(k+6)*dZoom;
                        Ansi1=Map.lpArray[i][3];
                        k=Ansi1.ToIntDef(0)*y_tran/y_org;
                        y1=(k-6)*dZoom;
                        y2=(k+6)*dZoom;
                        if (X>=x1 && X<=x2 && Y>=y1 && Y<=y2)
                                {
                                AnsiString Ansi="";
                                AnsiOAO="";
                                if (*Map.lpArray[i][1]!='#')
                                        {
                                        bAdrWrite=true;
                                        Ansi=". ";
                                        Ansi+=Map.lpArray[i][0];
                                        AnsiStreet=Map.lpArray[i][0];
                                        if (*Map.lpArray[i][1])
                                                {
                                                Ansi+=", .";
                                                Ansi+=Map.lpArray[i][1];
                                                AnsiHouse=Map.lpArray[i][1];
                                                if (MainForm->Prefs.bMoveMousePlan && !MainForm->Prefs.bPhotoOff)     FindAddr(FormPhoto->Image1, Map.lpArray[i][0], Map.lpArray[i][1], ALL);
                                                }
                                        else
                                                {
                                                if (MainForm->Prefs.bMoveMousePlan && !MainForm->Prefs.bPhotoOff)     FindAddr(FormPhoto->Image1, Map.lpArray[i][0], "", ONLY_STREET);
                                                }
                                        }
//                                else
//                                        {
                                        for (int n=Map.iAbonentsMap; n<(Map.iAbonentsMap+Map.iAbonentsMapOAO); n++)
                                               {
                                                if (!lstrcmp(Map.lpArray[i][0], Map.lpArray[n][2]) && !lstrcmp(Map.lpArray[i][1], Map.lpArray[n][3]) && *Map.lpArray[n][1]!='#')
                                                        {
                                                        if (bAdrWrite)
                                                                {
                                                                Ansi+=": ";
                                                                bAdrWrite=false;
                                                                AnsiOAO="";
                                                                }
                                                        else    {
                                                              //  AnsiStreet="";
                                                              //  AnsiHouse="";
                                                                if (Ansi!="")
                                                                        {
                                                                        Ansi+=", ";
                                                                        AnsiOAO+="|";  
                                                                        }
                                                                }
                                                        AnsiOAO+=Map.lpArray[n][1];
                                                        Ansi+=Map.lpArray[n][1];
                                                        if (MainForm->Prefs.bMoveMousePlan && !MainForm->Prefs.bPhotoOff)     FindAddr(FormPhoto->Image1, Map.lpArray[n][2], Map.lpArray[n][3], ALL);
                                                        }
                                                }
//                                        }
                                MainForm->StatusBar->SimpleText=Ansi;
                                bSet=true;
                                break;
                                }
                        }
                if (!bSet)
                        {
                        AnsiStreet="";
                        AnsiHouse="";
                        AnsiOAO="";
                        MainForm->StatusBar->SimpleText="";
                        Shape1->Hint="";
                        }
        }

if (MainForm->Prefs.bHil)       return;

static int X0,Y0,id_set=0;
static int busy=0;
int px,py;
if (busy)       return;
busy=1;
if(!Shift.Contains(ssLeft))
        {
        id_set=0;
        busy=0;
        return;
        }
if(!id_set && Shift.Contains(ssLeft))
        {
        X0=X;
        Y0=Y;
        id_set=1;
        busy=0;
        return;
        }
px=ScrollBox1->HorzScrollBar->Position;
py=ScrollBox1->VertScrollBar->Position;
ScrollBox1->HorzScrollBar->Position=px-(X-X0);
ScrollBox1->VertScrollBar->Position=py-(Y-Y0);
busy=0;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::ScrollBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (MainForm->Prefs.bHil)       return;
if (Shift.Contains(ssLeft) && !bDoubleClick)     Screen->Cursor=(TCursor) crMyCursor;
bDoubleClick=false;
}//-----------------------------------------------------------------------------
void __fastcall TFormMap::ScrollBox1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
Screen->Cursor = crDefault;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::PaintShape(int sx, int sy, int iWidth, int iColor)
{
Shape1->Brush->Color=(TColor) iColor;
Shape1->Width=iWidth;
Shape1->Height=iWidth;
Shape1->Left=ImageMap->Left+sx-iWidth/2;
Shape1->Top=ImageMap->Top+sy-iWidth/2;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::FormDestroy(TObject *Sender)
{
if (PageControl1->ActivePageIndex)      MainForm->Prefs.iMapN=1;
else    MainForm->Prefs.iMapN=0;
}
//------------------------------------------------------------------------------
void TFormMap::HowManyObjects()
{
int iHouses=0;
int iObjects=0;
for (int i=0;i<Map.iAbonentsMap;i++)
        {
        if (*(Map.lpArray[i][1])!='#' && *(Map.lpArray[i][1])) iHouses++;
        }

for (int i=Map.iAbonentsMap;i<Map.iAbonentsMap+Map.iAbonentsMapOAO;i++)
        {
        if (*(Map.lpArray[i][1])!='#') iObjects++;
        }
AnsiString aAnsi=": \n  - ";
aAnsi+=(iStreets-1);
aAnsi+=", \n - ";
aAnsi+=iHouses;
aAnsi+=", \n - ";
aAnsi+=iObjects;
aAnsi+=".";
PageControl1->Hint=aAnsi;
}
//------------------------------------------------------------------------------
void __fastcall TFormMap::N1Click(TObject *Sender)
{
PanelZoom->Height=67;
LabelX->Visible=true;
LabelY->Visible=true;
NCopy->Visible=true;
N6->Visible=true;
PanelZoom->PopupMenu=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::ImageMapDblClick(TObject *Sender)
{
Screen->Cursor = crDefault;
bDoubleClick=true;
TPoint p=TPoint(x, y);
p=ImageMap->ClientToScreen(p);
if (MainForm->StatusBar->SimpleText=="")
        {
        NHome->Enabled=false;
        NOAO->Enabled=false;

        }
else
        {
        NHome->Enabled=true;
        NOAO->Enabled=true;

        }
PopupMenuFind->Popup(p.x, p.y);
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::NHome2Click(TObject *Sender)
{
if (MainForm->Prefs.iPerehodAtMap>=2) return;
if (MainForm->ToolButtonHomePhones->Visible)
        {
        if (MainForm->bFormHomePhones)     FormHomePhones->Show();
        else         Application->CreateForm(__classid(TFormHomePhones), &FormHomePhones);

        FormHomePhones->ComboBoxPhone->Text="";
        FormHomePhones->ComboBoxMen->Text="";
        FormHomePhones->ComboBoxStreet->Text=AnsiStreet.c_str();
        FormHomePhones->ComboBoxHouse->Text=AnsiHouse.c_str();
        FormHomePhones->ButtonSearch->Click();

        FormMap->ShowAtMap(OPEN_HOTSPOT);
        MainForm->ShowAbonentAndMap(PHONES_ONLY_HOME);
        }
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::PopupMenuFindPopup(TObject *Sender)
{
AnsiString AnsiMenu="   ";
TMenu* tmenu=(TMenu*) Sender;

if (tmenu==PopupMenu3)
        {
//        MessageBox(NULL, "ddd","dddddd", MB_OK);
        AnsiStreet="";
        AnsiHouse="";
        AnsiOAO="";
        if (PageControl1->ActivePage==TabSheet2)
                {
               // MessageBox(NULL, "ddd","dddddd", MB_OK);
                if (TreeViewObjects->Selected!=NULL)    AnsiOAO=TreeViewObjects->Selected->Text;
                }
        else
                {
                if ( TreeViewStreets->Selected!=NULL)
                {

                TTreeNode* Node=TreeViewStreets->Selected;
                for (int n=0;n<TreeViewStreets->Items->Count;n++)
                        {
                        if (Node==TreeViewStreets->Items->Item[n])
                                {
                                AnsiStreet=Node->Text.c_str();
                                break;
                                }
                        else
                                {
                                for (int i=0; i<TreeViewStreets->Items->Item[n]->Count;i++)
                                        {
                                        if (Node==TreeViewStreets->Items->Item[n]->Item[i])
                                                {
                                                AnsiStreet=TreeViewStreets->Items->Item[n]->Text;
                                                AnsiHouse=Node->Text.c_str();
                                                break;
                                                }
                                        }
                                if (AnsiStreet != "") break;
                                }
                        }
                }
                }
        }
//MessageBox(NULL, AnsiStreet.c_str(),"dddddd", MB_OK);
if (AnsiStreet!="" && MainForm->bRunHomePhones && FormHomePhones->SearchAdrSaves(AnsiStreet.c_str(), AnsiHouse.c_str()))
        {
        NHome->Enabled=true;
        NHome2->Enabled=true;

        AnsiMenu+=" (.";
        AnsiMenu+=AnsiStreet.c_str();
        if (AnsiHouse!="")
                {
                AnsiMenu+=", .";
                AnsiMenu+=AnsiHouse.c_str();
                }
        AnsiMenu+=")";
        }
else
        {
        NHome->Enabled=false;
        NHome2->Enabled=false;
        }

if (AnsiOAO!="" && MainForm->bRunOAOPhones && FormOAOPhones->SearchNameSavesOAO(AnsiOAO.c_str()))
        {
        NOAO->Enabled=true;
        NOAO2->Enabled=true;
        }
 else
        {
        NOAO->Enabled=false;
        NOAO2->Enabled=false;
        }

NHome->Caption=AnsiMenu.c_str();
NHome2->Caption=AnsiMenu.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::NOAO2Click(TObject *Sender)
{
if (MainForm->Prefs.iPerehodAtMap>=2) return;
if (MainForm->ToolButtonOAOPhones->Visible)
        {
        if (MainForm->bFormOAOPhones)     FormOAOPhones->Show();
        else         Application->CreateForm(__classid(TFormOAOPhones), &FormOAOPhones);
        FormOAOPhones->RadioButton1->Checked=true;
        FormOAOPhones->ComboBoxOAO->Text=AnsiOAO.c_str();
        FormOAOPhones->ComboBoxPhone->Text="";
        FormOAOPhones->ButtonSearch->Click();

        FormMap->ShowAtMap(OPEN_HOTSPOT);
        MainForm->ShowAbonentAndMap(PHONES_ONLY_OAO);
        }
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::NCopyClick(TObject *Sender)
{
 HGLOBAL hglbTextCopyBuf = GlobalAlloc(GHND, AnsiCopy.Length()+1);
        if(hglbTextCopyBuf != NULL)
                {
                LPSTR lpTextCopy = (LPSTR)GlobalLock(hglbTextCopyBuf);
                if(lpTextCopy != NULL)
                        {
                        lstrcpy(lpTextCopy, AnsiCopy.c_str());
                        GlobalUnlock(hglbTextCopyBuf);
                        OpenClipboard(FormMap->Handle);
                        EmptyClipboard();
                        SetClipboardData(CF_TEXT, hglbTextCopyBuf);
                        CloseClipboard();
                        }
                }
}
//---------------------------------------------------------------------------
void __fastcall TFormMap::FormDeactivate(TObject *Sender)
{
MainForm->StatusBar->Font->Style=TFontStyles();        
}
//---------------------------------------------------------------------------

