#ifndef Unit1H
#define Unit1H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
//------------------------------------------------------------------------------
class TFormMap : public TForm
{
__published:	// IDE-managed Components
        TScrollBox *ScrollBox1;
        TPopupMenu *PopupMenu1;
        TMenuItem *NIncMap;
        TMenuItem *NDecMap;
        TMenuItem *N3;
        TMenuItem *N4;
        TTimer *Timer1;
        TMenuItem *N7;
        TPanel *Panel1;
        TPanel *Panel2;
        TBevel *Bevel1;
        TMenuItem *N5;
        TGroupBox *GroupBox2;
        TMemo *MemoAddition;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TTreeView *TreeViewStreets;
        TTreeView *TreeViewObjects;
        TButton *ButtonSpot;
        TImage *ImageMap;
        TShape *Shape1;
        TBevel *Bevel2;
        TBevel *Bevel3;
        TSpeedButton *LoopPlus;
        TSpeedButton *LoopMinus;
        TImageList *ImageList1;
        TPanel *PanelZoom;
        TLabel *LabelX;
        TLabel *LabelY;
        TPopupMenu *PopupMenu2;
        TMenuItem *N1;
        TPopupMenu *PopupMenuFind;
        TMenuItem *NHome;
        TMenuItem *NOAO;
        TPopupMenu *PopupMenu3;
        TMenuItem *NHome2;
        TMenuItem *NOAO2;
        TMenuItem *NCopy;
        TMenuItem *N6;
        void __fastcall LoopPlusClick(TObject *Sender);
        void __fastcall ImageResize();
        void __fastcall LoopMinusClick(TObject *Sender);
        void __fastcall CenterClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
        void __fastcall TreeViewStreetsChange(TObject *Sender, TTreeNode *Node);
        void __fastcall TreeViewStreetsMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Panel2Resize(TObject *Sender);
        void __fastcall N5Click(TObject *Sender);
        void __fastcall PageControl1Change(TObject *Sender);
        void __fastcall ButtonSpotClick(TObject *Sender);
        void __fastcall TreeViewObjectsChange(TObject *Sender, TTreeNode *Node);
        void __fastcall ScrollBox1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ScrollBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ScrollBox1MouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall N1Click(TObject *Sender);
        void __fastcall ImageMapDblClick(TObject *Sender);
        void __fastcall NHome2Click(TObject *Sender);
        void __fastcall PopupMenuFindPopup(TObject *Sender);
        void __fastcall NOAO2Click(TObject *Sender);
        void __fastcall NCopyClick(TObject *Sender);
        void __fastcall FormDeactivate(TObject *Sender);

private:
public:
	bool bPanelAddClosed;
        bool bPointStatus;
        int iRadiusDec;
        int iPointX;
        int iPointY;
        int iPointMainX;
        int iPointMainY;

        double dKoef;
        double  dZoom;
        int     iStreets;

        bool __fastcall FindAddr(TImage* Image, AnsiString, AnsiString, int);
        bool FindNameOAO(TImage* Image, AnsiString);
        void __fastcall LoopPlusMinus(int, double);
        void __fastcall PaintShape(int, int, int, int);
        void PrefsForMinComputer();
        void ShowAtMap(int);
        void CloseHot();
        void HowManyObjects();
         __fastcall TFormMap(TComponent* Owner);
};
//------------------------------------------------------------------------------
extern PACKAGE TFormMap *FormMap;
//------------------------------------------------------------------------------
#endif


