#include <vcl.h>
#pragma hdrstop

#include "Unit19.h"
#include "Main.h"
#include "Unit9.h"
#include "Unit7.h"
#include "Unit1.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormPrefs *FormPrefs;
//------------------------------------------------------------------------------
__fastcall TFormPrefs::TFormPrefs(TComponent* Owner)
        : TForm(Owner)
{
if (MainForm->bErrorToolBar) CheckBox4->Enabled=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::ButtonOkClick(TObject *Sender)
{
MainForm->Prefs.iPerehodAtMap=RadioGroup1->ItemIndex;
MainForm->Prefs.bAutoSearch=CheckBox3->Checked;
MainForm->Prefs.iWhereComputer=RadioGroup2->ItemIndex;
MainForm->Prefs.bNoIconsMenu=CheckBox4->Checked;
MainForm->Prefs.bNoLine=CheckBox5->Checked;
MainForm->Prefs.bNoTitle=CheckBoxTitle->Checked;
MainForm->Prefs.bNavodka=CheckBoxNavodka->Checked;
MainForm->StatusBar->Visible=!MainForm->Prefs.bNoLine;
MainForm->EnableBar(PANELTITLE, !MainForm->Prefs.bNoTitle);
if (!MainForm->bErrorToolBar)   MainForm->EnableBar(TOOLBUTTONS, !MainForm->Prefs.bNoIconsMenu);
MainForm->Prefs.bSeeAllSaves=CheckBoxSeeAllSaves->Checked;
MainForm->Prefs.bTips=CheckBoxTips->Checked;
MainForm->Prefs.bSelectionText=CheckBoxSelectionText->Checked;
MainForm->Prefs.bSaveText=CheckBoxSaveText->Checked;
MainForm->Prefs.bMoveMousePhoto=CheckBoxMoveMousePhoto->Checked;
MainForm->Prefs.bMoveMousePlan=CheckBoxMoveMousePlan->Checked;

if (MainForm->bFormMap)
        {
        FormMap->PrefsForMinComputer();
        }
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::ButtonCancelClick(TObject *Sender)
{
MainForm->StatusBar->Visible=!MainForm->Prefs.bNoLine;
MainForm->EnableBar(PANELTITLE, !MainForm->Prefs.bNoTitle);
if (!MainForm->bErrorToolBar)   MainForm->EnableBar(TOOLBUTTONS, !MainForm->Prefs.bNoIconsMenu);
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::ButtonPrefsClick(TObject *Sender)
{
TPoint p=TPoint(0, ButtonPrefs->Height);
p=ButtonPrefs->ClientToScreen(p);
PopupMenu1->Popup(p.x, p.y);
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::FormShow(TObject *Sender)
{
if (!MainForm->bFormMap)
        {
        CheckBoxNavodka->Enabled=false;
        }
if (MainForm->Prefs.iPerehodAtMap>2 || MainForm->Prefs.iPerehodAtMap<0)
        {
        RadioGroup1->Enabled=false;
        MainForm->Prefs.iPerehodAtMap=2;
        }
if (!MainForm->NTips->Visible)        CheckBoxTips->Enabled=false;

RadioGroup1->ItemIndex=MainForm->Prefs.iPerehodAtMap;
RadioGroup2->ItemIndex=MainForm->Prefs.iWhereComputer;
CheckBox3->Checked=MainForm->Prefs.bAutoSearch;
CheckBox4->Checked=MainForm->Prefs.bNoIconsMenu;
CheckBox5->Checked=MainForm->Prefs.bNoLine;
CheckBoxTitle->Checked=MainForm->Prefs.bNoTitle;
CheckBoxNavodka->Checked=MainForm->Prefs.bNavodka;
CheckBoxTips->Checked=MainForm->Prefs.bTips;
CheckBoxSeeAllSaves->Checked=MainForm->Prefs.bSeeAllSaves;
CheckBoxSelectionText->Checked=MainForm->Prefs.bSelectionText;
CheckBoxSaveText->Checked=MainForm->Prefs.bSaveText;
CheckBoxMoveMousePhoto->Checked=MainForm->Prefs.bMoveMousePhoto;
CheckBoxMoveMousePlan->Checked=MainForm->Prefs.bMoveMousePlan;

if (!MainForm->NSeePhoto->Enabled)
        {
        CheckBoxMoveMousePhoto->Enabled=false;
        CheckBoxMoveMousePlan->Enabled=false;
        }


}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::N1Click(TObject *Sender)
{
if (CheckBoxNavodka->Enabled) CheckBoxNavodka->Checked=true;
CheckBoxSeeAllSaves->Checked=false;
CheckBoxSelectionText->Checked=true;
CheckBox3->Checked=false;
if (MainForm->NSeePhoto->Enabled)
        {
        CheckBoxMoveMousePhoto->Checked=false;
        CheckBoxMoveMousePlan->Checked=false;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::N2Click(TObject *Sender)
{
if (CheckBoxNavodka->Enabled) CheckBoxNavodka->Checked=true;
CheckBoxSeeAllSaves->Checked=false;
CheckBoxSelectionText->Checked=false;
CheckBox3->Checked=false;
if (MainForm->NSeePhoto->Enabled)
        {
        CheckBoxMoveMousePhoto->Checked=false;
        CheckBoxMoveMousePlan->Checked=false;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::N3Click(TObject *Sender)
{
if (CheckBoxNavodka->Enabled) CheckBoxNavodka->Checked=false;
CheckBoxSeeAllSaves->Checked=true;
CheckBoxSelectionText->Checked=false;
CheckBox3->Checked=true;
if (MainForm->NSeePhoto->Enabled)
        {
        CheckBoxMoveMousePhoto->Checked=true;
        CheckBoxMoveMousePlan->Checked=true;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPrefs::CheckBox4Click(TObject *Sender)
{
if (!MainForm->bErrorToolBar)   MainForm->EnableBar(TOOLBUTTONS, !CheckBox4->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TFormPrefs::CheckBox5Click(TObject *Sender)
{
MainForm->StatusBar->Visible=!CheckBox5->Checked;
}
//---------------------------------------------------------------------------


void __fastcall TFormPrefs::CheckBoxTitleClick(TObject *Sender)
{
MainForm->EnableBar(PANELTITLE, !CheckBoxTitle->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TFormPrefs::FormClose(TObject *Sender,
      TCloseAction &Action)
{
MainForm->StatusBar->Visible=!MainForm->Prefs.bNoLine;
MainForm->EnableBar(PANELTITLE, !MainForm->Prefs.bNoTitle);
if (!MainForm->bErrorToolBar)   MainForm->EnableBar(TOOLBUTTONS, !MainForm->Prefs.bNoIconsMenu);
}
//---------------------------------------------------------------------------

