#ifndef Unit7H
#define Unit7H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <Buttons.hpp>
#include "Defines.h"
#include <Grids.hpp>
//------------------------------------------------------------------------------
class TFormOAOPhones : public TForm
{
__published:	// IDE-managed Components
        TGroupBox *GroupBoxResults;
        TPopupMenu *PopupMenu1;
        TMenuItem *NCopy;
        TMenuItem *N3;
        TMenuItem *NSeeAtMap;
        TMenuItem *N5;
        TMenuItem *NNewSearch;
        TMenuItem *NCall;
        TMenuItem *NAddInBook;
        TPanel *Panel3;
        TStringGrid *StringGrid1;
        THeaderControl *HeaderControl1;
        TStringGrid *StringGrid2;
        TStringGrid *StringGrid3;
        TPanel *Panel2;
        TBevel *Bevel1;
        TGroupBox *GroupBoxOAO;
        TImage *Image1;
        TComboBox *ComboBoxVRTZ;
        TComboBox *ComboBoxOAO;
        TComboBox *ComboBoxKGRES;
        TGroupBox *GroupBoxPhone;
        TImage *Image2;
        TComboBox *ComboBoxPhone;
        TButton *ButtonSearch;
        TButton *ButtonNewSearch;
        TGroupBox *GroupBox1;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TRadioButton *RadioButtonCategorie;
        TGroupBox *GroupBoxCategorie;
        TComboBox *ComboBoxCategorie;
        TStringGrid *StringGrid4;
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall NCopyClick(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall ComboBoxPhoneKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall NSeeAtMapClick(TObject *Sender);
        void __fastcall ComboBoxVRTZChange(TObject *Sender);
        void __fastcall ComboBox4Click(TObject *Sender);
        void __fastcall NCallClick(TObject *Sender);
        void __fastcall NAddInBookClick(TObject *Sender);
        void __fastcall HeaderControl1SectionResize(
          THeaderControl *HeaderControl, THeaderSection *Section);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall StringGrid1DrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall StringGrid3MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ButtonSearchClick(TObject *Sender);
        void __fastcall HeaderControl1SectionClick(
          THeaderControl *HeaderControl, THeaderSection *Section);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall RadioButton2Click(TObject *Sender);
        void __fastcall ComboBoxCategorieChange(TObject *Sender);
        void __fastcall ComboBoxPhoneChange(TObject *Sender);
        void __fastcall StringGrid4Click(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
public:
        int iRadioOAO;
        int iRadioKGRES;
        int iRadioVRTZ;
        char* cSearchOAO[32];
        bool  bSearchMapOAO;
        __fastcall TFormOAOPhones(TComponent* Owner);
        int SearchNameSavesOAO(char* cName);
        int SearchNumberSavesOAO(char*);
        int SearchNumberSavesKGRES(char*);
        int SearchNumberSavesVRTZ(char*);
        void TypeCategorie();
};
//------------------------------------------------------------------------------
extern PACKAGE TFormOAOPhones *FormOAOPhones;
//------------------------------------------------------------------------------
#endif
