#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit11.h"
#include "Unit83.h"
#include "Main.h"

#define INIT_Y  20

#pragma package(smart_init)
#pragma resource "*.dfm"

int iNormalW, iNormalH, iNormalX, iNormalY;

TFormPhoto *FormPhoto;
//------------------------------------------------------------------------------
__fastcall TFormPhoto::TFormPhoto(TComponent* Owner)
        : TForm(Owner)
{
char cPath[MAX_PATH];
GetCurrentDirectory(MAX_PATH, cPath);

AnsiString aBuf=cPath;
aBuf+=FILENAME_ADD_INI;
char* pcBuf=aBuf.c_str();

iNormalW=GetPrivateProfileInt("Photo", "Width", 0, pcBuf);
iNormalH=GetPrivateProfileInt("Photo", "Height", 0, pcBuf);
if (MainForm->Prefs.bPhotoOff=GetPrivateProfileInt("Photo", "PhotoOff", 1, pcBuf))
        {
        MainForm->NSeePhoto->Enabled=false;
        }
/*AnsiString aa=iNormalW;
aa+=" , ";
aa+=iNormalH;
MessageBox(NULL, aa.c_str(), pcBuf, MB_OK);*/

if (!MainForm->Prefs.iPhotoW && !MainForm->Prefs.iPhotoH && !MainForm->Prefs.iPhotoX && !MainForm->Prefs.iPhotoY)
        {
        FormPhoto->ClientWidth=iNormalW;
        FormPhoto->ClientHeight=iNormalH;
        iNormalX=Screen->DesktopWidth-FormPhoto->Width;
        iNormalY=INIT_Y;
        FormPhoto->Left=iNormalX;
        FormPhoto->Top=iNormalY;
        }
else
        {
        FormPhoto->Width=MainForm->Prefs.iPhotoW;
        FormPhoto->Height=MainForm->Prefs.iPhotoH;
        if (MainForm->Prefs.iPhotoX<Screen->DesktopWidth-INIT_Y)
                {
                FormPhoto->Left=MainForm->Prefs.iPhotoX;
                }
        else
                {
                iNormalX=Screen->DesktopWidth-INIT_Y;
                }
        if (MainForm->Prefs.iPhotoY<Screen->DesktopHeight-INIT_Y)
                {
                FormPhoto->Top=MainForm->Prefs.iPhotoY;
                }
        else
                {
                iNormalY=Screen->DesktopHeight-INIT_Y;
                }
        }

if (MainForm->Prefs.bPhotoProportional)
        {
        Image1->Proportional=true;
        NProportional->Checked=true;
        }
else
        {
        Image1->Proportional=false;
        NProportional->Checked=false;
        }
if (MainForm->Prefs.bPhoto && !MainForm->Prefs.bPhotoOff)
        {
        FormPhoto->Visible=true;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPhoto::NProportionalClick(TObject *Sender)
{
if (MainForm->Prefs.bPhotoProportional) MainForm->Prefs.bPhotoProportional=false;
else    MainForm->Prefs.bPhotoProportional=true;

if (MainForm->Prefs.bPhotoProportional)
        {
        Image1->Proportional=true;
        NProportional->Checked=true;
        }
else
        {
        Image1->Proportional=false;
        NProportional->Checked=false;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPhoto::FormDestroy(TObject *Sender)
{
if (!MainForm->Prefs.bPhotoOff)
        {
        MainForm->Prefs.iPhotoW=FormPhoto->Width;
        MainForm->Prefs.iPhotoH=FormPhoto->Height;
        MainForm->Prefs.iPhotoX=FormPhoto->Left;
        MainForm->Prefs.iPhotoY=FormPhoto->Top;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPhoto::FormClose(TObject *Sender,
      TCloseAction &Action)
{
if (FormPhoto->Visible) MainForm->Prefs.bPhoto=false;
if (MainForm->Prefs.bPhotoWarning)        FormPhotoWarning->ShowModal();
}
//------------------------------------------------------------------------------
void __fastcall TFormPhoto::FormShow(TObject *Sender)
{
MainForm->Prefs.bPhoto=true;
try
        {
        AnsiString Ansi="";
        Ansi+=DIRNAME_ADD_GFX;
        Ansi+="Main.jpg";
        FormPhoto->Image1->Picture->LoadFromFile(Ansi);
        }
catch (...)
        {
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPhoto::N1x11Click(TObject *Sender)
{
FormPhoto->ClientHeight=iNormalH;
FormPhoto->ClientWidth=iNormalW;        
}
//---------------------------------------------------------------------------

void __fastcall TFormPhoto::N2x21Click(TObject *Sender)
{
FormPhoto->ClientHeight=iNormalH*2;
FormPhoto->ClientWidth=iNormalW*2;        
}
//---------------------------------------------------------------------------

void __fastcall TFormPhoto::N3x31Click(TObject *Sender)
{
FormPhoto->ClientHeight=iNormalH*3;
FormPhoto->ClientWidth=iNormalW*3;
}
//---------------------------------------------------------------------------

void __fastcall TFormPhoto::N12x121Click(TObject *Sender)
{
FormPhoto->ClientHeight=iNormalH/2;
FormPhoto->ClientWidth=iNormalW/2;
}
//---------------------------------------------------------------------------

void __fastcall TFormPhoto::N3Click(TObject *Sender)
{
FormPhoto->Left=Screen->DesktopWidth-FormPhoto->Width;
FormPhoto->Top=INIT_Y;
}
//---------------------------------------------------------------------------

