#include <vcl.h>
#include <Tapi.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit6.h"
#include "Unit9.h"
#include "Unit83.h"
#include "Unit1.h"
#include "Main.h"
#include "CSV.cpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormHomePhones *FormHomePhones;
TCSVBase HOME=TCSVBase(FILENAME_PHONEHOME, 5);
//------------------------------------------------------------------------------
__fastcall TFormHomePhones::TFormHomePhones(TComponent* Owner)
    : TForm(Owner)
{
y=yold=-1;

MainForm->bFormHomePhones=true;
MainForm->bRunHomePhones=false;

if (HOME.bError)
        {
        MainForm->ToolButtonHomePhones->Visible=false;
        MainForm->NHomePhones->Visible=false;
        MainForm->bHome=false;
        Close();
        return;
        }
        
MainForm->bHome=true;
MainForm->bRunHomePhones=true;

try
        {
        Image1->Picture->LoadFromFile(FILENAME_PICTURE_PHONE);
        }
catch (...)
        {
        ComboBoxPhone->Width+=WIDTH_PICTURE;
        ComboBoxPhone->Left-=WIDTH_PICTURE;
        }
try
        {
        Image2->Picture->LoadFromFile(FILENAME_PICTURE_MEN);
        }
catch (...)
        {
        ComboBoxMen->Width+=WIDTH_PICTURE;
        ComboBoxMen->Left-=WIDTH_PICTURE;
        }
try
        {
        Image3->Picture->LoadFromFile(FILENAME_PICTURE_STREET);
        }
catch (...)
        {
        ComboBoxStreet->Width+=WIDTH_PICTURE;
        ComboBoxStreet->Left-=WIDTH_PICTURE;
        }
try
        {
        Image4->Picture->LoadFromFile(FILENAME_PICTURE_HOUSE);
        }
catch (...)
        {
        ComboBoxHouse->Width+=WIDTH_PICTURE;
        ComboBoxHouse->Left-=WIDTH_PICTURE;
        }
try
        {
        Image5->Picture->LoadFromFile(FILENAME_PICTURE_ROOM);
        }
catch (...)
        {
        ComboBoxRoom->Width+=WIDTH_PICTURE;
        ComboBoxRoom->Left-=WIDTH_PICTURE;
        }

if (HOME.iMaxNumSeparator<=4)
        {
        ButtonSearch->Left=328;
        ButtonNewSearch->Left=328;
        GroupBoxRoom->Visible=false;
        StringGrid1->ColCount=5;
        HeaderControl1->Sections->Delete(5);
        }

if (HOME.iMaxNumSeparator<=3)
        {
        GroupBoxHouse->Visible=false;
        StringGrid1->ColCount=4;
        HeaderControl1->Sections->Delete(4);
        }

if (HOME.iMaxNumSeparator<=2)
        {
        GroupBoxStreet->Visible=false;
        StringGrid1->ColCount=3;
        HeaderControl1->Sections->Delete(3);
        Panel2->Height-=20;
        }

try
        {
        ComboBoxStreet->Items->LoadFromFile(FILENAME_STREETS);
        }
catch (...)
        {
        ComboBoxStreet->Style=csSimple;
        }
StringGrid1->DoubleBuffered=true;

if (MainForm->Prefs.bSaveText)
        {
        ComboBoxPhone->Text=MainForm->Prefs.szHome1;
        ComboBoxMen->Text=MainForm->Prefs.szHome2;
        if (GroupBoxStreet->Visible) ComboBoxStreet->Text=MainForm->Prefs.szHome3;
        if (GroupBoxHouse->Visible) ComboBoxHouse->Text=MainForm->Prefs.szHome4;
        if (GroupBoxRoom->Visible) ComboBoxRoom->Text=MainForm->Prefs.szHome5;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::Button3Click(TObject *Sender)
{
ComboBoxPhone->Clear();
ComboBoxMen->Clear();
if (GroupBoxStreet->Visible)     ComboBoxStreet->Text="";
if (GroupBoxHouse->Visible)    ComboBoxHouse->Clear();
if (GroupBoxRoom->Visible)    ComboBoxRoom->Clear();

ButtonSearch->Enabled=true;
StringGrid1->Visible=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::ComboBoxPhoneChange(TObject *Sender)
{
ButtonSearch->Enabled=true;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormHomePhones=false;
MainForm->ToolButtonHomePhones->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::PopupMenu1Popup(TObject *Sender)
{
AnsiString aPhoneText="   ";

if (StringGrid1->Visible)
        {
        aPhoneText+=HOME.lpArrayBuf[StringGrid1->Selection.Top][0];
        aPhoneText+=" (";
        char cBuf[MAX_LEN_STRING];
        lstrcpy(cBuf, HOME.lpArrayBuf[StringGrid1->Selection.Top][1]);
        aPhoneText+=cBuf;
        aPhoneText+=")";
        NCall->Caption=aPhoneText;
        NCall->Enabled=true;
        }
if (MainForm->Prefs.iPerehodAtMap>=2)   NSeeAtMap->Enabled=false;
else 
        {
        if (MainForm->ToolButtonMap->Visible)
                {
                NSeeAtMap->Enabled=false;
                if (!MainForm->bFormMap) Application->CreateForm(__classid(TFormMap), &FormMap);
                if ((FormMap->FindAddr(NULL, HOME.lpArrayBuf[StringGrid1->Selection.Top][2], HOME.lpArrayBuf[StringGrid1->Selection.Top][3], ALL)) && MainForm->Prefs.iPerehodAtMap!=2)
                        {
                        NSeeAtMap->Enabled=true;
                        }
                }
        }
if (StringGrid1->Visible)
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }
else
        {
        NCopy->Enabled=false;
        NSeeAtMap->Enabled=false;
        NCall->Enabled=false;
        NAddInBook->Enabled=false;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, (void*) &HOME);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::FormActivate(TObject *Sender)
{
MainForm->ToolButtonHomePhones->Down=true;
MainForm->SeeTitle(FORM_HOME);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::NSeeAtMapClick(TObject *Sender)
{
if (MainForm->Prefs.iPerehodAtMap>=2) return;
if (MainForm->ToolButtonMap->Visible)
        {
        if (!MainForm->bFormMap) Application->CreateForm(__classid(TFormMap), &FormMap);
        if (FormMap->FindAddr(FormPhoto->Image1, HOME.lpArrayBuf[StringGrid1->Selection.Top][2], HOME.lpArrayBuf[StringGrid1->Selection.Top][3], ALL))
                {
                FormMap->Show();
                FormMap->ShowAtMap(CLOSE_HOTSPOT);
                MainForm->ShowAbonentAndMap(PHONES_ONLY_HOME);
                }
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::ComboBoxPhoneKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::NCallClick(TObject *Sender)
{
MainForm->CallDialer(HOME.lpArrayBuf[StringGrid1->Selection.Top][0], HOME.lpArrayBuf[StringGrid1->Selection.Top][1]);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, false, (void*) &HOME);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (!ACol)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
              &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==1 || ACol==4 || ACol==5)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle,HOME.lpArrayBuf[ARow][ACol-1],strlen(HOME.lpArrayBuf[ARow][ACol-1]),
            &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
int TFormHomePhones::SearchAdrSaves(char* cStreet, char* cHouse)
{
HOME.lpArrayScr[0]="";
HOME.lpArrayScr[1]="";
HOME.lpArrayScr[2]=cStreet;
HOME.lpArrayScr[3]=cHouse;
HOME.lpArrayScr[4]="";

int i=0;
if (!HOME.bError)
        {
        while (HOME.Find(SEARCH_HOME))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
int TFormHomePhones::SearchNumberSaves(char* cPhone)
{
HOME.lpArrayScr[0]=cPhone;
HOME.lpArrayScr[1]="";
HOME.lpArrayScr[2]="";
HOME.lpArrayScr[3]="";
HOME.lpArrayScr[4]="";

int i=0;
if (!HOME.bError)
        {
        while (HOME.Find(SEARCH_HOME))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
TStringGrid* StringGrid=(TStringGrid*) Sender;
y=(StringGrid->MouseCoord(X,Y)).Y;
if (y!=yold)
        {
        if (MainForm->bFormMap && MainForm->Prefs.bMoveMousePhoto && !MainForm->Prefs.bPhotoOff && MainForm->Prefs.bPhoto && y!=-1)
                {
                static AnsiString anAnOld3;
                static AnsiString anAnOld4;
                AnsiString anAn1=HOME.lpArrayBuf[y][2];
                AnsiString anAn2=HOME.lpArrayBuf[y][3];
                if (anAn1!=anAnOld3 || anAn2!=anAnOld4)
                        {
                        FormMap->FindAddr(FormPhoto->Image1, anAn1, anAn2, ALL);
                        }
                anAnOld3=anAn1;
                anAnOld4=anAn2;
                }
        if (!MainForm->Prefs.bSelectionText)
                {
                StringGrid->Repaint();
                }
        else
                {
                y=-1;
                }
        }
yold=y;

}
//------------------------------------------------------------------------------

void __fastcall TFormHomePhones::ButtonSearchClick(TObject *Sender)
{
//MainForm->ImageInHeaderControl(HeaderControl1, NULL, NULL, true);
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
char cPhone[MAX_LEN_STRING];
char cNameMen[MAX_LEN_STRING];
char cNameMenBuf[MAX_LEN_STRING];
char cNameStreet[MAX_LEN_STRING];
char cHouse[MAX_LEN_STRING];
char cRoom[MAX_LEN_STRING];
ButtonSearch->Enabled=false;
ComboBoxPhone->GetTextBuf(cPhone, MAX_LEN_STRING);
AnsiString aNameMen=ComboBoxMen->Text.c_str();
if (aNameMen.Length()>=3)
        {
        if (aNameMen[aNameMen.Length()-2]==' ' && aNameMen[aNameMen.Length()]!=' ' && aNameMen[aNameMen.Length()]!=' ' && aNameMen[aNameMen.Length()]!='.')
                {
                aNameMen.Insert(".",aNameMen.Length());
                }
        }
lstrcpy(cNameMen, aNameMen.c_str());
ComboBoxStreet->GetTextBuf(cNameStreet, MAX_LEN_STRING);
ComboBoxHouse->GetTextBuf(cHouse , MAX_LEN_STRING);
if (GroupBoxRoom->Visible)      ComboBoxRoom->GetTextBuf(cRoom , MAX_LEN_STRING);
else cRoom[0]=0;
HOME.CorrectHouse(cHouse);
HOME.lpArrayScr[0]=cPhone;
HOME.lpArrayScr[1]=cNameMen;
HOME.lpArrayScr[2]=cNameStreet;
HOME.lpArrayScr[3]=cHouse;
HOME.lpArrayScr[4]=cRoom;

ButtonSearch->Enabled=false;

int i=HOME.FindAll(SEARCH_HOME);
if (i)
        {
        AnsiString aAnsi=": ";
        aAnsi+=i;
        aAnsi+="  ";
        aAnsi+=HOME.iAbonents;
        aAnsi+="    ";
        DWORD dT2=GetTickCount();
        aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        aAnsi+=" .";
        StringGrid1->Hint=aAnsi;
        StringGrid1->RowCount=i;
        StringGrid1->Visible=true;
        MainForm->bNoMessageHelp=false;

        }
else
        {
        StringGrid1->Hint=" .";
        StringGrid1->Visible=false;
        MainForm->MessageHelp(SPRAVKA_PHONES);
        MainForm->bNoMessageHelp=false;

        }
StringGrid1->Repaint();
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int n;
for (n=0; HeaderControl->Sections->Count;n++)
        {
        if (HeaderControl->Sections->Items[n]==Section) break;
        }
if (!StringGrid1->Visible || !n) return;
HOME.SortArrayBuf(StringGrid1->RowCount, n-1);
//MainForm->ImageInHeaderControl(HeaderControl, Section, HOME.iDirectSort, false);
StringGrid1->Refresh();
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szHome1, ComboBoxPhone->Text.c_str());
lstrcpy(MainForm->Prefs.szHome2, ComboBoxMen->Text.c_str());
lstrcpy(MainForm->Prefs.szHome3, ComboBoxStreet->Text.c_str());
lstrcpy(MainForm->Prefs.szHome4, ComboBoxHouse->Text.c_str());
lstrcpy(MainForm->Prefs.szHome5, ComboBoxRoom->Text.c_str());
}
//------------------------------------------------------------------------------
void __fastcall TFormHomePhones::StringGrid1Click(TObject *Sender)
{
if (MainForm->bFormMap)
        {
        AnsiString anAn1=HOME.lpArrayBuf[StringGrid1->Selection.Top][2];
        AnsiString anAn2=HOME.lpArrayBuf[StringGrid1->Selection.Top][3];
        FormMap->FindAddr(FormPhoto->Image1, anAn1, anAn2, ALL);
        }
}
//------------------------------------------------------------------------------



