!include "MUI.nsh"


;ShowInstDetails show
CRCCheck on

SetDatablockOptimize on
SetOverwrite on

InstType ""
Name ""
OutFile "c:\Projects\Finish_VIS\Setup.exe"
InstallDir "$PROGRAMFILES\"

!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\win.bmp" ; optional
;!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
;!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"
;!define MUI_UI_COMPONENTSPAGE_NODESC


!define MUI_CUSTOMPAGECOMMANDS
!define MUI_LICENSEPAGE
!define MUI_COMPONENTSPAGE
!define MUI_DIRECTORYPAGE
!define MUI_ABORTWARNING
!define MUI_UNINSTALLER
!define MUI_UNCONFIRMPAGE

!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_PAGE_LICENSE "c:\Projects\VIS4\LicenseVIS.txt"


!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH
 
Section ""
SectionIn 1 2 3 RO
Call .GetWindowsVersion

;Delete "$INSTDIR\Data\Addition_Gfx\*.*"
Delete "$INSTDIR\Data\Addition_Text\*.*"
Delete "$INSTDIR\Data\Main_Gfx\*.*"
;Delete "$INSTDIR\Data\*.*"
Delete "$INSTDIR\*.*"

DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\"
Delete "$SMPROGRAMS\\*.*"
RMDir "$SMPROGRAMS\"
Delete "$DESKTOP\.lnk"


;Good1:
SetOutPath $INSTDIR
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\" "DisplayName" ""
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\" "UninstallString" '"$INSTDIR\ .exe"'

File "c:\Projects\VIS4\.exe"
File "c:\Projects\VIS4\.exe.manifest"
File "c:\Projects\VIS4\.htm"
;File "c:\Projects\VIS4\Register.txt"
;File "c:\Projects\VIS4\ .htm"
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\Tips.txt"
File "c:\Projects\VIS4\Data\Index.css"
File "c:\Projects\VIS4\Data\Index_help.css"
File "c:\Projects\VIS4\Data\Bus.htm"
;File "c:\Projects\VIS4\Data\PhonesHome.txt"
File "c:\Projects\VIS4\Data\PhonesOAO.txt"
File "c:\Projects\VIS4\Data\PhonesKGRES.txt"
File "c:\Projects\VIS4\Data\PhonesVrTZ.txt"
File "c:\Projects\VIS4\Data\Categories.txt"
File "c:\Projects\VIS4\Data\Dial.htm"
File "c:\Projects\VIS4\Data\Streets.txt"
File "c:\Projects\VIS4\Data\Others.htm"
File "c:\Projects\VIS4\Data\Map.txt"
File "c:\Projects\VIS4\Data\Map.emf"
File "c:\Projects\VIS4\Data\banner.gif"
File "c:\Projects\VIS4\Data\banner.htm"
File "c:\Projects\VIS4\Data\String.ini"
SetOutPath $INSTDIR\Data\Addition_Text
File "c:\Projects\VIS4\Data\Addition_Text\*.*"

SetOutPath $INSTDIR\Data\Addition_GFX
File "c:\Projects\VIS4\Data\Addition_GFX\*.*"

SetOutPath $INSTDIR\Data\Main_Gfx
File "c:\Projects\VIS4\Data\Main_GFX\*.*"

SetOutPath $INSTDIR

CreateShortCut "$DESKTOP\.lnk" "$INSTDIR\.exe" '"$INSTDIR\.exe" /CD'
CreateDirectory "$SMPROGRAMS\"
CreateShortCut "$SMPROGRAMS\\.lnk" "$INSTDIR\.exe"
CreateShortCut "$SMPROGRAMS\\.lnk" "$INSTDIR\.htm"
WriteUninstaller " .exe"
CreateShortCut "$SMPROGRAMS\\ .lnk" "$INSTDIR\ .exe"

;ExecShell "open" '"$INSTDIR"'

;SetAutoClose true
SectionEnd


Section "Uninstall"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\"
Delete "$INSTDIR\Data\Addition_Gfx\*.*"
RMDir "$INSTDIR\Data\Addition_Gfx"

Delete "$INSTDIR\Data\Addition_Text\*.*"
RMDir "$INSTDIR\Data\Addition_Text"

Delete "$INSTDIR\Data\Main_Gfx\*.*"
RMDir "$INSTDIR\Data\Main_Gfx"

Delete "$INSTDIR\Data\*.*"
RMDir "$INSTDIR\Data"
Delete "$INSTDIR\*.*"
RMDir "$INSTDIR"
Delete "$SMPROGRAMS\\*.*"
RMDir "$SMPROGRAMS\"
Delete "$DESKTOP\.lnk"
MessageBox MB_YESNO "        ?" IDNO NoAbort
		Delete "$WINDIR\VIS.ini"
		Delete "$WINDIR\VIS_Book.txt"
NoAbort:
IfFileExists "$INSTDIR" 0 NoErrorMsg
MessageBox MB_OK ":     '$INSTDIR' !" IDOK 0 ; skipped if file doesn't exist
goto Exit
NoErrorMsg:
HideWindow 
;SetAutoClose true
Exit:

SectionEnd


Function .GetWindowsVersion
  ReadRegStr $0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber
  StrCpy $9 $0 3
  StrCmp $9 '4.0' lbl_win32_95
  Goto lbl_done
lbl_win32_95:
  StrCpy $0 '95'
  MessageBox MB_OK|MB_ICONSTOP ":  Windows 98  ."
  Quit
  Goto lbl_done
lbl_done:

FunctionEnd


SubSection " " SectionSprav
Section "  " SectionCity
SectionIn 1
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\CityCodes.txt"
File "c:\Projects\VIS4\Data\KostromaCodes.txt"
File "c:\Projects\VIS4\Data\OldCities.txt"
SetOutPath $INSTDIR
SectionEnd

Section "  " SectionCountry
SectionIn 1
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\CountryCodes.txt"
SetOutPath $INSTDIR
SectionEnd

Section " " SectionMobile
SectionIn 1
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\MobileCodes.txt"
SetOutPath $INSTDIR
SectionEnd

Section " " SectionPost
SectionIn 1
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\PostIndexes.txt"
SetOutPath $INSTDIR
SectionEnd

Section "  " SectionAuto
SectionIn 1
SetOutPath $INSTDIR\Data
File "c:\Projects\VIS4\Data\Regions.txt"
SetOutPath $INSTDIR
SectionEnd
SubSectionEnd


Section "   " SectionGFX
SectionIn 1 2 3 RO

SetOutPath $INSTDIR\Data\Addition_GFX
File "c:\Projects\VIS4\Data\Addition_GFX\*.*"
SetOutPath $INSTDIR

SectionEnd