//------------------------------------------------------------------------------
//  :  ../Hidden Codes 2002-2004.
// www.hcodes.narod.ru, mailto: hcodes@narod.ru

#pragma hdrstop

#include "CSV.cpp"
#include "Main.h"
#pragma resource "*.dfm"

TMainForm *MainForm;

char cWinDir[MAX_PATH];
char cCurDir[MAX_PATH];
int iSizeTitle;
int iPosTitle;
AnsiString aTitle;
AnsiString aPartTitle;

//------------------------------------------------------------------------------
void PathAddBackslash1(char* cText)
{
if (*(cText+lstrlen(cText)-1)!='\\')
        {
        lstrcat(cText, "\\");
        }
}
//------------------------------------------------------------------------------
void TMainForm::LoadINIFile()
{
aBufIniDir=cWinDir;
aBufIniDir+=FILENAME_PREFS;
char* pcBuf=aBufIniDir.c_str();

Prefs.bAutoSearch=GetPrivateProfileInt("PREFS", "AutoSearch", 0, pcBuf);
Prefs.iPerehodAtMap=GetPrivateProfileInt("PREFS", "PerehodAtMap", 1, pcBuf);
Prefs.bWinMax=GetPrivateProfileInt("PREFS", "WinMax", 1, pcBuf);
Prefs.iWinX=GetPrivateProfileInt("PREFS", "WinX", 0, pcBuf);
Prefs.iWinY=GetPrivateProfileInt("PREFS", "WinY", 0, pcBuf);
Prefs.iWhereComputer=GetPrivateProfileInt("PREFS", "WhereComputer", 0, pcBuf);
Prefs.bNoIconsMenu=GetPrivateProfileInt("PREFS", "NoIconsMenu", 0, pcBuf);
Prefs.bNoTitle=GetPrivateProfileInt("PREFS", "NoTitle", 0, pcBuf);
Prefs.bSmallIcons=GetPrivateProfileInt("PREFS", "SmallIcons", 0, pcBuf);
Prefs.bTips=GetPrivateProfileInt("PREFS", "Tips", 0, pcBuf);
Prefs.bNoLine=GetPrivateProfileInt("PREFS", "NoLine", 0, pcBuf);
Prefs.bShemaClosed=GetPrivateProfileInt("PREFS", "ShemaClosed", 0, pcBuf);
Prefs.bNavodka=GetPrivateProfileInt("PREFS", "Navodka", 1, pcBuf);
Prefs.bTitul=GetPrivateProfileInt("PREFS", "Titul", 1, pcBuf);
Prefs.bSeeAllSaves=GetPrivateProfileInt("PREFS", "SeeAllSaves", 0, pcBuf);
Prefs.bSelectionText=GetPrivateProfileInt("PREFS", "SelectionText", 0, pcBuf);
Prefs.iRegionN=GetPrivateProfileInt("PREFS", "RegionN", 0, pcBuf);
Prefs.bSaveText=GetPrivateProfileInt("PREFS", "SaveText", 1, pcBuf);
Prefs.bMoveMousePhoto=GetPrivateProfileInt("PREFS", "MoveMousePhoto", 1, pcBuf);
Prefs.bMoveMousePlan=GetPrivateProfileInt("PREFS", "MoveMousePlan", 1, pcBuf);
Prefs.bTextEffect=GetPrivateProfileInt("PREFS", "TextEffect", 1, pcBuf);
Prefs.bBreak=GetPrivateProfileInt("PREFS", "Break", 1, pcBuf);
Prefs.bPhotoWarning=GetPrivateProfileInt("PREFS", "PhotoWarning", 1, pcBuf);
Prefs.bToolBarFirst=GetPrivateProfileInt("PREFS", "ToolBarFirst", 1, pcBuf);

GetPrivateProfileString("PREFS", "Home1", "", Prefs.szHome1, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Home2", "", Prefs.szHome2, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Home3", "", Prefs.szHome3, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Home4", "", Prefs.szHome4, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Home5", "", Prefs.szHome5, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Country", "", Prefs.szCountry, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "City", "", Prefs.szCity, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Post", "", Prefs.szPost, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "Mobile", "", Prefs.szMobile, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "OAO", "", Prefs.szOAO, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("PREFS", "OAOPhone", "", Prefs.szOAOPhone, MAX_LEN_STRING, pcBuf);
Prefs.iOAOCatN=GetPrivateProfileInt("PREFS", "OAOCatN", 1, pcBuf);
Prefs.iOAON=GetPrivateProfileInt("PREFS", "OAON", 1, pcBuf);
Prefs.iMapN=GetPrivateProfileInt("PREFS", "MapN", 1, pcBuf);

Prefs.bPhotoProportional=GetPrivateProfileInt("PREFS", "PhotoProportional", 1, pcBuf);

Prefs.bPhoto=GetPrivateProfileInt("PREFS", "Photo", 1, pcBuf);

Prefs.iPhotoX=GetPrivateProfileInt("PREFS", "PhotoX", 0, pcBuf);
Prefs.iPhotoY=GetPrivateProfileInt("PREFS", "PhotoY", 0, pcBuf);
Prefs.iPhotoW=GetPrivateProfileInt("PREFS", "PhotoW", 0, pcBuf);
Prefs.iPhotoH=GetPrivateProfileInt("PREFS", "PhotoH", 0, pcBuf);

if (Prefs.iPerehodAtMap>1 || Prefs.iPerehodAtMap<0) Prefs.iPerehodAtMap=1;

if (Prefs.bWinMax)
        {
        MainForm->WindowState=wsMaximized;
        }
else
        {
        MainForm->WindowState=wsNormal;
        MainForm->Width=Prefs.iWinX;
        MainForm->Height=Prefs.iWinY;
        }
}
//------------------------------------------------------------------------------
void TMainForm::LoadINIString()
{
AnsiString aAnsi=cCurDir;
aAnsi+=FILENAME_STRING;
char* pcBuf=aAnsi.c_str();

GetPrivateProfileString("STRING", "Title", PROG_TITLE, cTitle, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Title1", PROG_TITLE1, cTitle1, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Title2", PROG_TITLE2, cTitle2, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Mail", PROG_MAIL, cMail, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "ShortMail", PROG_SHORTMAIL, cShortMail, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Inet", PROG_INET, cInet, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "ShortInet", PROG_SHORTINET, cShortInet, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Version", PROG_VERSION, cVersion, MAX_LEN_STRING, pcBuf);
GetPrivateProfileString("STRING", "Date", PROG_DATE, cDate, MAX_LEN_STRING, pcBuf);

}
//------------------------------------------------------------------------------
void TMainForm::SaveINIFile()
{
char* pcBuf=aBufIniDir.c_str();

AnsiString aAnsi=(int) Prefs.bAutoSearch;
WritePrivateProfileString("PREFS", "AutoSearch", aAnsi.c_str(), pcBuf);
aAnsi=Prefs.iPerehodAtMap;
WritePrivateProfileString("PREFS", "PerehodAtMap", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bWinMax;
WritePrivateProfileString("PREFS", "WinMax", aAnsi.c_str(), pcBuf);
aAnsi=Prefs.iWinX;
WritePrivateProfileString("PREFS", "WinX", aAnsi.c_str(), pcBuf);
aAnsi=Prefs.iWinY;
WritePrivateProfileString("PREFS", "WinY", aAnsi.c_str(), pcBuf);
aAnsi=Prefs.iWhereComputer;
WritePrivateProfileString("PREFS", "WhereComputer", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bNoIconsMenu;
WritePrivateProfileString("PREFS", "NoIconsMenu", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bNoTitle;
WritePrivateProfileString("PREFS", "NoTitle", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bSmallIcons;
WritePrivateProfileString("PREFS", "SmallIcons", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bTips;
WritePrivateProfileString("PREFS", "Tips", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bNoLine;
WritePrivateProfileString("PREFS", "NoLine", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bShemaClosed;
WritePrivateProfileString("PREFS", "ShemaClosed", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bNavodka;
WritePrivateProfileString("PREFS", "Navodka", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bTitul;
WritePrivateProfileString("PREFS", "Titul", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bSeeAllSaves;
WritePrivateProfileString("PREFS", "SeeAllSaves", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bSelectionText;
WritePrivateProfileString("PREFS", "SelectionText", aAnsi.c_str(), pcBuf);
aAnsi=Prefs.iRegionN;
WritePrivateProfileString("PREFS", "RegionN", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bSaveText;
WritePrivateProfileString("PREFS", "SaveText", aAnsi.c_str(), pcBuf);
aAnsi=(int) Prefs.bMoveMousePhoto;
WritePrivateProfileString("PREFS", "MoveMousePhoto", aAnsi.c_str(), pcBuf);
aAnsi=(int)Prefs.bMoveMousePlan;
WritePrivateProfileString("PREFS", "MoveMousePlan", aAnsi.c_str(), pcBuf);
aAnsi=(int)Prefs.bTextEffect;
WritePrivateProfileString("PREFS", "TextEffect", aAnsi.c_str(), pcBuf);
aAnsi=(int)Prefs.bBreak;
WritePrivateProfileString("PREFS", "Break", aAnsi.c_str(), pcBuf);
aAnsi=(int)Prefs.bToolBarFirst;
WritePrivateProfileString("PREFS", "ToolBarFirst", aAnsi.c_str(), pcBuf);
aAnsi=(int)Prefs.bPhotoWarning;
WritePrivateProfileString("PREFS", "PhotoWarning", aAnsi.c_str(), pcBuf);

WritePrivateProfileString("PREFS", "Home1", Prefs.szHome1, pcBuf);
WritePrivateProfileString("PREFS", "Home2", Prefs.szHome2, pcBuf);
WritePrivateProfileString("PREFS", "Home3", Prefs.szHome3, pcBuf);
WritePrivateProfileString("PREFS", "Home4", Prefs.szHome4, pcBuf);
WritePrivateProfileString("PREFS", "Home5", Prefs.szHome5, pcBuf);

WritePrivateProfileString("PREFS", "City", Prefs.szCity, pcBuf);
WritePrivateProfileString("PREFS", "Country", Prefs.szCountry, pcBuf);
WritePrivateProfileString("PREFS", "Post", Prefs.szPost, pcBuf);
WritePrivateProfileString("PREFS", "Mobile", Prefs.szMobile, pcBuf);
WritePrivateProfileString("PREFS", "OAO", Prefs.szOAO, pcBuf);
WritePrivateProfileString("PREFS", "OAOPhone", Prefs.szOAOPhone, pcBuf);

aAnsi=(int) Prefs.iOAON;
WritePrivateProfileString("PREFS", "OAON", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iOAOCatN;
WritePrivateProfileString("PREFS", "OAOCatN", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iMapN;
WritePrivateProfileString("PREFS", "MapN", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iPhotoX;
WritePrivateProfileString("PREFS", "PhotoX", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iPhotoY;
WritePrivateProfileString("PREFS", "PhotoY", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iPhotoW;
WritePrivateProfileString("PREFS", "PhotoW", aAnsi.c_str(), pcBuf);

aAnsi=(int) Prefs.iPhotoH;
WritePrivateProfileString("PREFS", "PhotoH", aAnsi.c_str(), pcBuf);

aAnsi=(int)Prefs.bPhoto;
WritePrivateProfileString("PREFS", "Photo", aAnsi.c_str(), pcBuf);

aAnsi=(int)Prefs.bPhotoProportional;
WritePrivateProfileString("PREFS", "PhotoProportional", aAnsi.c_str(), pcBuf);

}
//------------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent *Owner)
	: TForm(Owner)
{
hShell32=LoadLibrary("Shell32.dll");
bNoMessageHelp=false;
GetWindowsDirectory(cWinDir, MAX_PATH);
PathAddBackslash1(cWinDir);
GetCurrentDirectory(MAX_PATH, cCurDir);
PathAddBackslash1(cCurDir);

Graphics::TBitmap *bm = new Graphics::TBitmap();

bErrorToolBar=false;
bErrorToolBarBook=false;
bErrorSmallIcons=false;

LoadINIFile();
LoadINIString();

try
        {
        bm->LoadFromFile(FILENAME_TB_PHONESHOME);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_PHONESOAO);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_SEARCHPHONE);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_DIAL);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_MAP);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_POSTINDEXES);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_EMPTYBOOK);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_FULLBOOK);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_REGIONS);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_OTHERS);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_CITYCODES);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_COUNTRYCODES);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_AUTOBUS);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_MOBILECODES);
        ImageList1->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TB_BANNER);
        ImageList1->AddMasked(bm, clFuchsia);
        }
catch (...)
        {
        bErrorBigIcons=true;
        }

try
        {
        bm->LoadFromFile(FILENAME_TBM_PHONESHOME);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_PHONESOAO);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_SEARCHPHONE);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_DIAL);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_MAP);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_POSTINDEXES);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_EMPTYBOOK);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_FULLBOOK);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_REGIONS);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_OTHERS);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_CITYCODES);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_COUNTRYCODES);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_AUTOBUS);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_MOBILECODES);
        ImageList3->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_TBM_BANNER);
        ImageList3->AddMasked(bm, clFuchsia);
        }
catch (...)
        {
        bErrorSmallIcons=true;
        }
if (bErrorSmallIcons && bErrorBigIcons)
        {
        bErrorToolBar=true;
        ToolBar1->Visible=false;
        NSmallIcons->Enabled=false;
        }
if (bErrorSmallIcons && !bErrorBigIcons)
        {
        Prefs.bSmallIcons=false;
        NSmallIcons->Enabled=false;
        }
if (!bErrorSmallIcons && bErrorBigIcons)
        {
        Prefs.bSmallIcons=true;
        NSmallIcons->Enabled=false;
        }
try
        {
        bm->LoadFromFile(FILENAME_OG_COPY);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_SELECT);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_NEW);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_SEE);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_MINIPHONE);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_PLUS);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_CUT);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_PASTE);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_UNDO);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_NORMAL);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_LUPE_PLUS);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_LUPE_MINUS);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_LUPE_FIND);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_SAVE);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_LOAD);
        ImageList2->AddMasked(bm, clFuchsia);
        bm->LoadFromFile(FILENAME_OG_PRINT);
        ImageList2->AddMasked(bm, clFuchsia);
        }
catch (...)
        {
        bErrorToolBarBook=true;
        ImageList2->Clear();
        }

delete bm;


lstrcat(cTitle, ", ");
lstrcat(cTitle, cVersion);
lstrcat(cTitle, " ");
lstrcat(cTitle, cDate);

MainForm->Caption=cTitle;

randomize();

LoadKeyboardLayout("00000419",KLF_ACTIVATE);

ToolBar1->DoubleBuffered=true;
MainForm->DoubleBuffered=true;
PanelTitle->DoubleBuffered=true;

if (Prefs.bSmallIcons)
        {
        ToolBar1->Images=ImageList3;
        ToolBar1->ButtonHeight=34;
        ToolBar1->ButtonWidth=34;
        }
else
        {
        ToolBar1->Images=ImageList1;
        ToolBar1->ButtonHeight=46;
        ToolBar1->ButtonWidth=47;
        }

int iBuf1=CoolBar1->Bands->Items[0]->MinHeight;
int iBuf2=CoolBar1->Bands->Items[1]->MinHeight;

if (!Prefs.bToolBarFirst)
        {
        CoolBar1->Bands->Items[1]->MinHeight=iBuf1;
        CoolBar1->Bands->Items[0]->MinHeight=iBuf2;
        CoolBar1->Bands->Items[0]->Control=PanelTitle;
        CoolBar1->Bands->Items[1]->Control=ToolBar1;

        }
CoolBar1->Bands->Items[1]->Break=Prefs.bBreak;

if (Prefs.bSelectionText && !Prefs.bSeeAllSaves && Prefs.bNavodka && !Prefs.bAutoSearch && !MainForm->Prefs.bMoveMousePhoto && !MainForm->Prefs.bMoveMousePlan)        MainForm->Prefs.bHil=true;
else    MainForm->Prefs.bHil=false;

if (Prefs.bNoIconsMenu)       EnableBar(TOOLBUTTONS, false);
if (Prefs.bNoTitle)   EnableBar(PANELTITLE, false);
if (Prefs.bNoLine)      StatusBar->Visible=false;

}
//------------------------------------------------------------------------------
void __fastcall TMainForm::FileNew1Execute(TObject *Sender)
{
ToolButtonHomePhones->Down=true;
if (bFormHomePhones)     FormHomePhones->Show();
else         Application->CreateForm(__classid(TFormHomePhones), &FormHomePhones);
FormHomePhones->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::FileExit1Execute(TObject *Sender)
{
Close();
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonDialClick(TObject *Sender)
{
ToolButtonDial->Down=true;
if (bFormDial)       FormDial->Show();
else       Application->CreateForm(__classid(TFormDial), &FormDial);
FormDial->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonBusClick(TObject *Sender)
{
ToolButtonBus->Down=true;
if (bFormBus)       FormBus->Show();
else      Application->CreateForm(__classid(TFormBus), &FormBus);
FormBus->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonBookClick(TObject *Sender)
{
ToolButtonBook->Down=true;
if (bFormBook)       FormBook->Show();
else       Application->CreateForm(__classid(TFormBook), &FormBook);
//FormBook->WindowState=wsMaximized;

}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NSpravkaClick(TObject *Sender)
{
ShellExecute( MainForm->Handle, "open", FILENAME_SPRAVKA, NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonMapClick(TObject *Sender)
{
ToolButtonMap->Down=true;
if (bFormMap)        FormMap->Show();
else      Application->CreateForm(__classid(TFormMap), &FormMap);
FormMap->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonOAOPhonesClick(TObject *Sender)
{
ToolButtonOAOPhones->Down=true;
if (bFormOAOPhones)  FormOAOPhones->Show();
else     Application->CreateForm(__classid(TFormOAOPhones), &FormOAOPhones);
FormOAOPhones->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonRegionsClick(TObject *Sender)
{
ToolButtonRegions->Down=true;
if (bFormRegions)       FormRegions->Show();
else       Application->CreateForm(__classid(TFormRegions), &FormRegions);
FormRegions->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonCityCodesClick(TObject *Sender)
{
ToolButtonCityCodes->Down=true;
if (bFormCityCodes)       FormCityCodes->Show();
else       Application->CreateForm(__classid(TFormCityCodes), &FormCityCodes);
FormCityCodes->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonCountryCodesClick(TObject *Sender)
{
ToolButtonCountryCodes->Down=true;
if (bFormCountryCodes)       FormCountryCodes->Show();
else       Application->CreateForm(__classid(TFormCountryCodes), &FormCountryCodes);
FormCountryCodes->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonOthersClick(TObject *Sender)
{
ToolButtonOthers->Down=true;
if (bFormOthers)       FormOthers->Show();
else       Application->CreateForm(__classid(TFormOthers), &FormOthers);
FormOthers->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NTipsClick(TObject *Sender)
{
FormTips->Show();
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (MainForm->WindowState==wsMaximized)
        {
        Prefs.bWinMax=true;
        }
else
        {
        Prefs.bWinMax=false;
        Prefs.iWinX=MainForm->Width;
        Prefs.iWinY=MainForm->Height;
        }

Prefs.bBreak=CoolBar1->Bands->Items[1]->Break;

if (CoolBar1->Bands->Items[0]->Control==ToolBar1)       Prefs.bToolBarFirst=true;
else    Prefs.bToolBarFirst=false;

SaveINIFile();

}
//------------------------------------------------------------------------------
void TMainForm::MessageHelp(int iType)
{
AnsiString aAnsi="   .";
if (iType!=SPRAVKA_DEFAULT)
{
        aAnsi+="\n\n  :\n1.      .\n2.      ";
        if (iType==SPRAVKA_PHONES)      aAnsi+="09.";
        else    aAnsi+="8-12.";
}

if (!Prefs.bAutoSearch && !bNoMessageHelp) Application->MessageBox(aAnsi.c_str(), "", MB_OK|MB_ICONWARNING);

bNoMessageHelp=false;
}
//------------------------------------------------------------------------------
void TMainForm::ShowAbonentAndMap(int i)
{
if (!Prefs.iPerehodAtMap==1) return;
if (i==PHONES_ONLY_OAO)
        {
        if (bFormHomePhones)    FormHomePhones->Close();
        }
else
        {
        if (bFormOAOPhones)     FormOAOPhones->Close();
        }
if (bFormBus)   FormBus->Close();
if (bFormBook)  FormBook->Close();
if (bFormDial)  FormDial->Close();
if (bFormBanner)  FormBanner->Close();
if (bFormRegions)       FormRegions->Close();
if (bFormCityCodes)     FormCityCodes->Close();
if (bFormCountryCodes)  FormCountryCodes->Close();
if (bFormOthers)        FormOthers->Close();
if (bFormPost)  FormPost->Close();
if (bFormMobileCodes)   FormMobileCodes->Close();

Application->ProcessMessages();
TileMode=tbVertical;
Tile();
}
//----    StringGrid' -> Clipboard   -
void TMainForm::CopyAt(void* StringGrid, bool bCopyAtClipboard, void* CSV)
{
TCSVBase* CSVBase=(TCSVBase*) CSV;
TStringGrid * StringGrid1=(TStringGrid*) StringGrid;
AnsiString ansi="";
int iLeft=StringGrid1->FixedCols;
if (!bCopyAtClipboard)
        {
        if (!bFormBook)       Application->CreateForm(__classid(TFormBook), &FormBook);
        }
for (int n=StringGrid1->Selection.Top; n<=StringGrid1->Selection.Bottom; n++)
        {
        if (!CSVBase)
                for (int i=iLeft;i<=StringGrid1->Selection.Right; i++)
                        {
                        ansi+=StringGrid1->Cells[i][n].c_str();
                        if (i!=StringGrid1->Selection.Right) ansi+=SEPARATOR;
                        }
        else
                {
                for (int l=0; l<CSVBase->iColumn; l++)
                        {
                        ansi+=CSVBase->lpArrayBuf[n][l];
                        if (l!=(CSVBase->iColumn-1))    ansi+=SEPARATOR;
                        }
                }
        if (n!=StringGrid1->Selection.Bottom) ansi+="\x0d\x0a";
        }
if (bCopyAtClipboard)
        {
        HGLOBAL hglbTextCopyBuf = GlobalAlloc(GHND, ansi.Length()+1);
        if(hglbTextCopyBuf != NULL)
                {
                LPSTR lpTextCopy = (LPSTR)GlobalLock(hglbTextCopyBuf);
                if(lpTextCopy != NULL)
                        {
                        lstrcpy(lpTextCopy, ansi.c_str());
                        GlobalUnlock(hglbTextCopyBuf);
                        OpenClipboard(FormOAOPhones->Handle);
                        EmptyClipboard();
                        SetClipboardData(CF_TEXT, hglbTextCopyBuf);
                        CloseClipboard();
                        }
                }
        }
else
        {
        FormBook->Memo1->Lines->Add(ansi.c_str());
        }
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NAboutProgClick(TObject *Sender)
{
FormAbout->ShowModal();
}
//------------------------------------------------------------------------------
void TMainForm::CallDialer(AnsiString anAnsi, AnsiString anAnsi2)
{
anAnsi.Delete(anAnsi.Pos(","),anAnsi.Length()-anAnsi.Pos(",")+1);
for (int i=0; i<5; i++) anAnsi.Delete(anAnsi.Pos("-"), 1);

if (anAnsi.Length()>=2)
        {
        char* cText=anAnsi.c_str();
        switch (Prefs.iWhereComputer)
                {
                case 1:
                        if (*cText=='7' && *(cText+1)=='2')
                                {
                                anAnsi.Delete(1,1);
                                }
                        else  if (*cText!='2') anAnsi.Insert("9W",1);
                        break;
                case 2:
                        if (*cText=='7' && *(cText+1)>='8')
                                {
                                anAnsi.Delete(1,1);
                                }
                        else if (*cText<'8') anAnsi.Insert("0W",1);
                        break;
                }
        tapiRequestMakeCall( anAnsi.c_str(), NULL, anAnsi2.c_str(), NULL);
        }
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NVisInInetClick(TObject *Sender)
{
ShellExecute( MainForm->Handle, "open", cInet, NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NPrefsClick(TObject *Sender)
{
FormPrefs->ShowModal();
}
//------------------------------------------------------------------------------
void TMainForm::NumToStringGrid(void* vStringGrid, int iNum)
{
TStringGrid* StringGrid=(TStringGrid*)vStringGrid;
for (int i=0; i<iNum;i++)       StringGrid->Cells[0][i]=i+1;
}
//------------------------------------------------------------------------------
void TMainForm::ResizeStringGrid(void* vStringGrid, void* vHeaderControl)
{
TStringGrid* StringGrid=(TStringGrid*) vStringGrid;
THeaderControl* HeaderControl=(THeaderControl*) vHeaderControl;
for (int i=0; i<StringGrid->ColCount;i++)       StringGrid->ColWidths[i]=HeaderControl->Sections->Items[i]->Width-1 ;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonSearchPhoneClick(TObject *Sender)
{
FormSearchPhone->ShowModal();
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonPostClick(TObject *Sender)
{
ToolButtonPost->Down=true;
if (bFormPost)       FormPost->Show();
else       Application->CreateForm(__classid(TFormPost), &FormPost);
FormPost->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void TMainForm::LoadInetAdr(void* CppWebBrowser, char* cAdr)
{
TCppWebBrowser* Web=(TCppWebBrowser*) CppWebBrowser;
AnsiString Ansi2=GetCurrentDir();
if (Ansi2.AnsiLastChar()!="\\") Ansi2+="\\";
AnsiString Ansi="file://";
Ansi+=Ansi2.c_str();
Ansi+=cAdr;
int iLen=MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, Ansi.c_str(), -1, NULL ,0);
wchar_t *wAdr=new wchar_t[iLen];
MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, Ansi.c_str(), -1, wAdr , iLen);
Web->Navigate(wAdr, TNoParam(), TNoParam(), TNoParam(), TNoParam());
delete[] wAdr;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NWriteLettersClick(TObject *Sender)
{
ShellExecute( MainForm->Handle, "open", cMail, NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------
typedef struct
{
int ARow;
AnsiString S;
} TMyData;
//------------------------------------------------------------------------------
static int __fastcall CompareUp(void * Item1, void * Item2)
{
return ((TMyData *)Item1)->S.AnsiCompare(((TMyData *)Item2)->S);
}
//------------------------------------------------------------------------------
static int __fastcall CompareDown(void * Item1, void * Item2)
{
return ((TMyData *)Item2)->S.AnsiCompare(((TMyData *)Item1)->S);
}
//------------------------------------------------------------------------------
void TMainForm::SortStringGrid(void* vStringGrid,int ACol,int DirectSort)
{
TStringGrid *StringGrid=(TStringGrid *)vStringGrid;
int i,j,ARow;
if (!DirectSort)return;
if (!StringGrid->Visible)return;
if (ACol<StringGrid->FixedCols) return;
TList *SortList=new TList;
TList *TempList=new TList;
for (ARow=0; ARow < StringGrid->RowCount; ARow++)
        {
        TMyData *md=new TMyData;
        md->ARow=ARow;
        md->S=StringGrid->Cells[ACol][ARow];
        SortList->Add(md);
        TempList->Add((void *)ARow);
        }
if (DirectSort==1) SortList->Sort(CompareUp);
else SortList->Sort(CompareDown);
for (i=0; i < SortList->Count; i++)
        {
        TMyData *md=(TMyData *)(SortList->Items[i]);
        ARow=md->ARow;
        for (j=0; j < TempList->Count; j++)
                {
                if (ARow==(int)TempList->Items[j])      break;
                }
        for (int l=StringGrid->FixedCols; l<StringGrid->ColCount; l++)
                {
                AnsiString Sold=StringGrid->Cells[l][j];
                AnsiString Snew=StringGrid->Cells[l][i];
                StringGrid->Cells[l][j]=Snew;
                StringGrid->Cells[l][i]=Sold;
                }
        int jold=(int)(TempList->Items[j]);
        int inew=(int)(TempList->Items[i]);
        TempList->Items[j]=(void *)inew;
        TempList->Items[i]=(void *)jold;
        }
delete TempList;
for(i=0; i < SortList->Count; i++)
        {
        delete (TMyData *)(SortList->Items[i]);
        }
delete SortList;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
ToolButtonBanner->Down=true;
ToolButtonHomePhones->Down=false;
ToolButtonOAOPhones->Down=false;
ToolButtonDial->Down=false;
ToolButtonBook->Down=false;
ToolButtonCityCodes->Down=false;
ToolButtonCountryCodes->Down=false;
ToolButtonPost->Down=false;
ToolButtonRegions->Down=false;
ToolButtonMap->Down=false;
ToolButtonBus->Down=false;
ToolButtonOthers->Down=false;
ToolButtonMobileCodes->Down=false;

int iVisible=0;
for (int i=0; i<ToolBar1->ButtonCount; i++)
        {
        if (ToolBar1->Buttons[i]->Visible) iVisible++;
        }
if (iVisible==2)
        {
        N1->Visible=false;
        ToolButton1->Visible=false;
        NPrefs->Enabled=false;
        }
if (!ToolButtonMobileCodes->Visible &&  !ToolButtonCityCodes->Visible && !ToolButtonCountryCodes->Visible && !ToolButtonPost->Visible && !ToolButtonRegions->Visible)
        {
        ToolButton2->Visible=false;
        N3->Visible=false;
        }
if (MainForm->MDIChildCount) MainForm->MDIChildren[0]->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::FormPaint(TObject *Sender)
{
static bool bStart=false;
if (!bStart)
        {
        bStart=true;
        if ( MainForm->NTips->Visible && Prefs.bTips) FormTips->Show();
        }
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::ToolButtonMobileCodesClick(TObject *Sender)
{
ToolButtonMobileCodes->Down=true;
if (bFormMobileCodes)       FormMobileCodes->Show();
else       Application->CreateForm(__classid(TFormMobileCodes), &FormMobileCodes);
FormMobileCodes->WindowState=wsMaximized;
}
//------------------------------------------------------------------------------
bool TMainForm::PathFileExists1(char* cFile)
{
HANDLE hHandFile;

if ((hHandFile=CreateFile(cFile, GENERIC_READ,FILE_SHARE_READ,
                NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL)) != INVALID_HANDLE_VALUE)
        {
        CloseHandle(hHandFile);
        return true;
        }

return false;
}
//------------------------------------------------------------------------------
void __fastcall TMainForm::NSeePhotoClick(TObject *Sender)
{
if (!Prefs.bPhotoOff)
        {
        Prefs.bPhoto=true;
        FormPhoto->Show();
        }
}
//------------------------------------------------------------------------------

void __fastcall TMainForm::NButtonsClick(TObject *Sender)
{
if (NButtons->Checked)
        {
        EnableBar(TOOLBUTTONS, true);
        MainForm->Prefs.bNoIconsMenu=false;
        }
else
        {
        EnableBar(TOOLBUTTONS, false);
        MainForm->Prefs.bNoIconsMenu=true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NSmallIconsClick(TObject *Sender)
{
Prefs.bSmallIcons=NSmallIcons->Checked;
if (Prefs.bSmallIcons)
        {
        ToolBar1->Images=ImageList3;
        ToolBar1->ButtonHeight=34;
        ToolBar1->ButtonWidth=34;
        }
else
        {
        ToolBar1->Images=ImageList1;
        ToolBar1->ButtonHeight=46;
        ToolBar1->ButtonWidth=47;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PopupMenu1Popup(TObject *Sender)
{
NSmallIcons->Checked=Prefs.bSmallIcons;
NTextEffect->Checked=Prefs.bTextEffect;
NLine->Checked=!Prefs.bNoLine;
NButtons->Checked=!Prefs.bNoIconsMenu;
NTitle->Checked=!Prefs.bNoTitle;
}
//---------------------------------------------------------------------------
void TMainForm::SeeTitle(int iForm)
{
static int iRepeat=-1;

if (iRepeat==iForm) return;
iRepeat=iForm;

switch (iForm)
        {
        case FORM_BANNER:
                aTitle=NBanner->Caption;
        break;
        case FORM_DIAL:
                aTitle=NDial->Caption;
        break;
       case FORM_BOOK:
                aTitle=NBook->Caption;
        break;
        case FORM_BUS:
                aTitle=NBus->Caption;
        break;
        case FORM_MAP:
                aTitle=NMap->Caption;
        break;
        case FORM_CODES:
                aTitle=NCityCodes->Caption;
        break;
        case FORM_ICODES:
                aTitle=NCountryCodes->Caption;
        break;
        case FORM_MOBILE:
                aTitle=NMobileCodes->Caption;
        break;
        case FORM_POST:
                aTitle=NPost->Caption;
        break;
        case FORM_OTHERS:
                aTitle=NOthers->Caption;
        break;
        case FORM_OAO:
                aTitle=NOAOPhones->Caption;
        break;
        case FORM_HOME:
                aTitle=NHomePhones->Caption;
        break;
        case FORM_REGIONS:
                aTitle=NRegions->Caption;
        break;
        }
        if (!Prefs.bTextEffect)
                {
                PanelTitle->Caption=aTitle;
                return;
                }
        iSizeTitle=aTitle.Length();
        iPosTitle=1;
        aPartTitle="";
        Timer2->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer2Timer(TObject *Sender)
{
static bCheck=true;
if (!iPosTitle) bCheck=true;

if (iPosTitle<=iSizeTitle)
        {
        aPartTitle+=aTitle[iPosTitle];
        }
iPosTitle++;

if (iPosTitle>iSizeTitle+11)
        {
        Timer2->Enabled=false;
        bCheck=false;
        }
AnsiString AnsiBuf="";
AnsiBuf+=aPartTitle.c_str();
if (bCheck)     AnsiBuf+="|";
bCheck=!bCheck;
PanelTitle->Caption=AnsiBuf;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NTitleClick(TObject *Sender)
{
if (NTitle->Checked)
        {
        EnableBar(PANELTITLE, true);
        MainForm->Prefs.bNoTitle=false;
        }
else
        {
        EnableBar(PANELTITLE, false);
        MainForm->Prefs.bNoTitle=true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NLineClick(TObject *Sender)
{
if (NLine->Checked)
        {
        MainForm->StatusBar->Visible=true;
        MainForm->Prefs.bNoLine=false;
        }
else
        {
        MainForm->StatusBar->Visible=false;
        MainForm->Prefs.bNoLine=true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NTextEffectClick(TObject *Sender)
{
MainForm->Prefs.bTextEffect=NTextEffect->Checked;
}
//---------------------------------------------------------------------------
void TMainForm::EnableBar(int iWindow, bool bEnabled)
{
for (int i=0; i<=CoolBar1->Bands->Count-1; i++)
        {
        if (CoolBar1->Bands->Items[i]->Control==PanelTitle && iWindow==PANELTITLE)
                {
                CoolBar1->Bands->Items[i]->Visible=bEnabled;
                }
        if (CoolBar1->Bands->Items[i]->Control==ToolBar1 && iWindow==TOOLBUTTONS)
                {
                CoolBar1->Bands->Items[i]->Visible=bEnabled;
                }
         }
}
//---------------------------------------------------------------------------













void __fastcall TMainForm::ToolButtonBannerClick(TObject *Sender)
{
ToolButtonBanner->Down=true;
if (bFormBanner)       FormBanner->Show();
else       Application->CreateForm(__classid(TFormBanner), &FormBanner);
FormBanner->WindowState=wsMaximized;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NBannerClick(TObject *Sender)
{
ToolButtonBanner->Down=true;
if (bFormBanner)     FormBanner->Show();
else         Application->CreateForm(__classid(TFormBanner), &FormBanner);
FormBanner->WindowState=wsMaximized;
}
//---------------------------------------------------------------------------

