#include <vcl.h>
#pragma hdrstop
#include "Unit7.h"
#include "Unit9.h"
#include "Unit10.h"
#include "Unit13.h"
#include "Unit14.h"
#include "Unit81.h"
#include "Unit20.h"

#include "Main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormSearchPhone *FormSearchPhone;
int iHome=0, iOAO=0, iKGRES=0, iVRTZ=0, iCityCodes=0, iCountryCodes=0, iMobileCodes=0, iPost=0;
//------------------------------------------------------------------------------
__fastcall TFormSearchPhone::TFormSearchPhone(TComponent* Owner)
        : TForm(Owner)
{
if (!MainForm->bHome && !MainForm->bOAO && !MainForm->bKGRES && !MainForm->bVRTZ && !MainForm->bCityCodes && !MainForm->bCountryCodes && !MainForm->bMobileCodes && !MainForm->bPost)
        {
        MainForm->ToolButtonSearchPhone->Visible=false;
        MainForm->NSearchPhone->Visible=false;
        return;
        }

try
        {
        ImagePhone->Picture->LoadFromFile(FILENAME_PICTURE_PHONE);
        }
catch(...)
        {
        ComboBoxPhone->Width+=WIDTH_PICTURE;
        ComboBoxPhone->Left-=WIDTH_PICTURE;
        }
DWORD dwColor=GetSysColor(COLOR_GRAYTEXT);
if (!MainForm->bHome)
        {
        Button1->Enabled=false;
        LabelTextHome->Font->Color=dwColor;
        LabelHome->Font->Color=dwColor;
        }
if (!MainForm->bOAO)
        {
        Button2->Enabled=false;
        LabelTextOAO->Font->Color=dwColor;
        LabelOAO->Font->Color=dwColor;
        }
if (!MainForm->bKGRES)
        {
        Button3->Enabled=false;
        LabelTextKGRES->Font->Color=dwColor;
        LabelKGRES->Font->Color=dwColor;
        }
if (!MainForm->bVRTZ)
        {
        Button4->Enabled=false;
        LabelTextVRTZ->Font->Color=dwColor;
        LabelVRTZ->Font->Color=dwColor;
        }
if (!MainForm->bCityCodes)
        {
        Button5->Enabled=false;
        LabelTextCityCodes->Font->Color=dwColor;
        LabelCityCodes->Font->Color=dwColor;
        }
if (!MainForm->bCountryCodes)
        {
        Button6->Enabled=false;
        LabelTextCountryCodes->Font->Color=dwColor;
        LabelCountryCodes->Font->Color=dwColor;
        }
if (!MainForm->bMobileCodes)
        {
        Button7->Enabled=false;
        LabelTextMobileCodes->Font->Color=dwColor;
        LabelMobileCodes->Font->Color=dwColor;
        }
if (!MainForm->bPost)
        {
        Button8->Enabled=false;
        LabelTextPost->Font->Color=dwColor;
        LabelPost->Font->Color=dwColor;
        }
}

//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::FormShow(TObject *Sender)
{
LabelHome->Caption="";
LabelOAO->Caption="";
LabelKGRES->Caption="";
LabelVRTZ->Caption="";
LabelCityCodes->Caption="";
LabelCountryCodes->Caption="";
LabelMobileCodes->Caption="";
LabelPost->Caption="";
iHome=iOAO=iKGRES=iVRTZ=iCityCodes=iCountryCodes=iMobileCodes=iPost=0;
GroupBox1->Hint="";
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::ButtonSearchClick(TObject *Sender)
{
AnsiString aInput=ComboBoxPhone->Text.c_str();
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
if (Button1->Enabled)   iHome=FormHomePhones->SearchNumberSaves(aInput.c_str());
if (Button2->Enabled)   iOAO=FormOAOPhones->SearchNumberSavesOAO(aInput.c_str());
if (Button3->Enabled)
        {
        AnsiString aInput1=ComboBoxPhone->Text.c_str();
        if (aInput1.Length())
        if (aInput1[1]!='7' && aInput1[1]=='2' && aInput1.Length()<5)   aInput1.Insert("7",1);
        iKGRES=FormOAOPhones->SearchNumberSavesKGRES(aInput1.c_str());
        }
if (Button4->Enabled)
        {
        AnsiString aInput2=ComboBoxPhone->Text.c_str();
         if (aInput2.Length())
         if (aInput2[1]!='7' && (aInput2[1]=='8' || aInput2[1]=='9')&& aInput2.Length()<5)      aInput2.Insert("7",1);
        iVRTZ=FormOAOPhones->SearchNumberSavesVRTZ(aInput2.c_str());
        }
if (Button5->Enabled)   iCityCodes=FormCityCodes->SearchNumberSaves(aInput.c_str());
if (Button6->Enabled)   iCountryCodes=FormCountryCodes->SearchNumberSaves(aInput.c_str());
if (Button7->Enabled)   iMobileCodes=FormMobileCodes->SearchNumberSaves(aInput.c_str());
if (Button8->Enabled)   iPost=FormPost->SearchNumberSaves(aInput.c_str());

AnsiString aAnsi=" ";
aAnsi+=iHome+iOAO+iKGRES+iVRTZ;
aAnsi+=" ()  ";
DWORD dT2=GetTickCount();
aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
aAnsi+=" .";
GroupBox1->Hint=aAnsi;

LabelHome->Caption=iHome;
LabelOAO->Caption=iOAO;
LabelKGRES->Caption=iKGRES;
LabelVRTZ->Caption=iVRTZ;
LabelCityCodes->Caption=iCityCodes;
LabelCountryCodes->Caption=iCountryCodes;
LabelMobileCodes->Caption=iMobileCodes;
LabelPost->Caption=iPost;

if ((iHome+iOAO+iKGRES+iVRTZ+iCityCodes+iCountryCodes+iMobileCodes+iPost)==1)
        {
        if (iHome)
                {
                MainForm->ToolButtonHomePhones->Click();
                FormHomePhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
                FormHomePhones->ComboBoxMen->Text="";
                FormHomePhones->ComboBoxStreet->Text="";
                FormHomePhones->ComboBoxHouse->Text="";
                FormHomePhones->ButtonSearch->Click();
                }
        if (iOAO)
                {
                MainForm->ToolButtonOAOPhones->Click();
                FormOAOPhones->RadioButton1->Checked=true;
                FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
                FormOAOPhones->ComboBoxOAO->Text="";
                FormOAOPhones->ButtonSearch->Click();
                }
        if (iKGRES)
                {
                MainForm->ToolButtonOAOPhones->Click();
                FormOAOPhones->RadioButton2->Checked=true;
                FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
                FormOAOPhones->ComboBoxKGRES->Text="";
                FormOAOPhones->ButtonSearch->Click();
                }
        if (iVRTZ)
                {
                MainForm->ToolButtonOAOPhones->Click();
                FormOAOPhones->RadioButton3->Checked=true;
                FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
                FormOAOPhones->ComboBoxVRTZ->Text="";
                FormOAOPhones->ButtonSearch->Click();
                }
        if (iCityCodes)
                {
                MainForm->ToolButtonCityCodes->Click();
                FormCityCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
                FormCityCodes->ButtonSearch->Click();
                }
        if (iCountryCodes)
                {
                MainForm->ToolButtonCountryCodes->Click();
                FormCountryCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
                FormCountryCodes->ButtonSearch->Click();
                }
        if (iMobileCodes)
                {
                MainForm->ToolButtonMobileCodes->Click();
                FormMobileCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
                FormMobileCodes->ButtonSearch->Click();
                }
        if (iPost)
                {
                MainForm->ToolButtonPost->Click();
                FormPost->ComboBox1->Text=ComboBoxPhone->Text.c_str();
                FormPost->ButtonSearch->Click();
                }

        }
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::Button1Click(TObject *Sender)
{
MainForm->ToolButtonHomePhones->Click();
if (iHome)
        {
        FormHomePhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
        FormHomePhones->ComboBoxMen->Text="";
        FormHomePhones->ComboBoxStreet->Text="";
        FormHomePhones->ComboBoxHouse->Text="";
        FormHomePhones->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::Button2Click(TObject *Sender)
{
MainForm->ToolButtonOAOPhones->Click();
FormOAOPhones->RadioButton1->Checked=true;
if (iOAO)
        {
        FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
        FormOAOPhones->ComboBoxOAO->Text="";
        FormOAOPhones->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::Button3Click(TObject *Sender)
{
MainForm->ToolButtonOAOPhones->Click();
FormOAOPhones->RadioButton2->Checked=true;

if (iKGRES)
        {
        FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
        FormOAOPhones->ComboBoxKGRES->Text="";
        FormOAOPhones->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::Button4Click(TObject *Sender)
{
MainForm->ToolButtonOAOPhones->Click();
FormOAOPhones->RadioButton3->Checked=true;
if (iVRTZ)
        {
        FormOAOPhones->ComboBoxPhone->Text=ComboBoxPhone->Text.c_str();
        FormOAOPhones->ComboBoxVRTZ->Text="";
        FormOAOPhones->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::ComboBoxPhoneChange(TObject *Sender)
{
ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::ComboBoxPhoneKeyPress(TObject *Sender,
      char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormSearchPhone::ButtonSearchKeyPress(TObject *Sender,
      char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------

void __fastcall TFormSearchPhone::Button5Click(TObject *Sender)
{
MainForm->ToolButtonCityCodes->Click();
if (iCityCodes)
        {
        FormCityCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
        FormCityCodes->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------

void __fastcall TFormSearchPhone::Button6Click(TObject *Sender)
{
MainForm->ToolButtonCountryCodes->Click();
if (iCountryCodes)
        {
        FormCountryCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
        FormCountryCodes->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------

void __fastcall TFormSearchPhone::Button7Click(TObject *Sender)
{
MainForm->ToolButtonMobileCodes->Click();
if (iMobileCodes)
        {
        FormMobileCodes->ComboBox1->Text=ComboBoxPhone->Text.c_str();
        FormMobileCodes->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------

void __fastcall TFormSearchPhone::Button8Click(TObject *Sender)
{
MainForm->ToolButtonPost->Click();
if (iPost)
        {
        FormPost->ComboBox1->Text=ComboBoxPhone->Text.c_str();
        FormPost->ButtonSearch->Click();
        }
Close();
}
//------------------------------------------------------------------------------

void __fastcall TFormSearchPhone::FormClose(TObject *Sender,
      TCloseAction &Action)
{
//
//
        
}
//---------------------------------------------------------------------------

