#ifndef Unit13H
#define Unit13H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
//------------------------------------------------------------------------------
class TFormCityCodes : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TGroupBox *GroupBox1;
        TComboBox *ComboBox1;
        TPopupMenu *PopupMenu1;
        TMenuItem *NCopy;
        TBevel *Bevel1;
        TMenuItem *NNewSearch;
        TPopupMenu *PopupMenu2;
        TMenuItem *NKostromaCodes;
        TMenuItem *NOldNames;
        TMenuItem *NAddInBook;
        TButton *ButtonNewSearch;
        TButton *ButtonSearch;
        TButton *ButtonAddition;
        THeaderControl *HeaderControl1;
        TStringGrid *StringGrid1;
        TPanel *Panel2;
        TButton *Button1;
        TButton *Button2;
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall NCopyClick(TObject *Sender);
        void __fastcall ComboBox1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall NOldNamesClick(TObject *Sender);
        void __fastcall NAddInBookClick(TObject *Sender);
        void __fastcall ButtonAdditionClick(TObject *Sender);
        void __fastcall HeaderControl1SectionResize(
          THeaderControl *HeaderControl, THeaderSection *Section);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall StringGrid1DrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall StringGrid1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall ButtonSearchClick(TObject *Sender);
        void __fastcall NKostromaCodesClick(TObject *Sender);
        void __fastcall ButtonNewSearchClick(TObject *Sender);
        void __fastcall HeaderControl1SectionClick(
          THeaderControl *HeaderControl, THeaderSection *Section);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);

private:	// User declarations
public:
        int y;
        int yold;

        int SearchNumberSaves(char* cCode);
        __fastcall TFormCityCodes(TComponent* Owner);
};
//------------------------------------------------------------------------------
extern PACKAGE TFormCityCodes *FormCityCodes;
//------------------------------------------------------------------------------
#endif
