#include <vcl.h>
#pragma hdrstop

#include "Unit15.h"
#include "Main.h"
#include "CSV.cpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormRegions *FormRegions;
TCSVBase REGIONS=TCSVBase(FILENAME_REGIONS, 3);
int y=-1;
int yold=-1;
//------------------------------------------------------------------------------
__fastcall TFormRegions::TFormRegions(TComponent* Owner)
        : TForm(Owner)
{
if (REGIONS.bError)
        {
        MainForm->ToolButtonRegions->Visible=false;
        MainForm->NRegions->Visible=false;
        Close();
        return;
        }

MainForm->bFormRegions=true;

for (int i = 0; i < REGIONS.iAbonents; i++)
        {
        StringGrid1->Cells[0][i]=REGIONS.lpArray[i][0];
        StringGrid1->Cells[1][i]=REGIONS.lpArray[i][1];
        StringGrid1->Cells[2][i]=REGIONS.lpArray[i][2];
        }
StringGrid1->RowCount=REGIONS.iAbonents;
StringGrid1->DoubleBuffered=true;

if (MainForm->Prefs.bSaveText)  RadioGroup1->ItemIndex=MainForm->Prefs.iRegionN;

}
//------------------------------------------------------------------------------

void __fastcall TFormRegions::RadioGroup1Click(TObject *Sender)
{
REGIONS.lpArrayScr[2]="";

if (RadioGroup1->ItemIndex==1) REGIONS.lpArrayScr[2]="";
if (RadioGroup1->ItemIndex==2) REGIONS.lpArrayScr[2]="";
if (RadioGroup1->ItemIndex==3) REGIONS.lpArrayScr[2]="";
if (RadioGroup1->ItemIndex==4) REGIONS.lpArrayScr[2]=" ";
if (RadioGroup1->ItemIndex==5) REGIONS.lpArrayScr[2]=" ";
if (RadioGroup1->ItemIndex==6) REGIONS.lpArrayScr[2]="";
if (RadioGroup1->ItemIndex==7) REGIONS.lpArrayScr[2]="";


int i=0;
while(REGIONS.Find(SEARCH_REGIONS))
        {
        StringGrid1->Cells[0][i]=REGIONS.lpArrayDest[0];
        StringGrid1->Cells[1][i]=REGIONS.lpArrayDest[1];
        StringGrid1->Cells[2][i++]=REGIONS.lpArrayDest[2];
        }
if (i)
        {
        StringGrid1->RowCount=i;
        StringGrid1->Visible=true;
        }
else
        {
        StringGrid1->Visible=false;
         }
StringGrid1->Repaint();
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormRegions=false;
MainForm->ToolButtonRegions->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::FormActivate(TObject *Sender)
{
MainForm->ToolButtonRegions->Down=true;
MainForm->SeeTitle(FORM_REGIONS);
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*)StringGrid1, false, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------

void __fastcall TFormRegions::FormShow(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------

void __fastcall TFormRegions::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (!ACol)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
    &Rect,iTextFlag);

}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        y=(StringGrid1->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid1->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------


void __fastcall TFormRegions::PopupMenu1Popup(TObject *Sender)
{
if (StringGrid1->Visible)
        {
        NAddInBook->Enabled=true;
        NCopy->Enabled=true;
        }
else
        {
        NAddInBook->Enabled=false;
        NCopy->Enabled=false;
        }
}
//------------------------------------------------------------------------------

void __fastcall TFormRegions::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
static int iDirection=1;
iDirection*=-1;
int i;
for (i=0; HeaderControl->Sections->Count;i++)
        {
        if (HeaderControl->Sections->Items[i]==Section) break;
        }
REGIONS.iDirectSort[i]*=-1;
MainForm->SortStringGrid((void*) StringGrid1, i, REGIONS.iDirectSort[i]);
}
//------------------------------------------------------------------------------
void __fastcall TFormRegions::FormDestroy(TObject *Sender)
{
MainForm->Prefs.iRegionN=RadioGroup1->ItemIndex;
}
//------------------------------------------------------------------------------
