#pragma hdrstop

#include "Unit18.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormTips *FormTips;
//------------------------------------------------------------------------------
__fastcall TFormTips::TFormTips(TComponent* Owner)
        : TForm(Owner)
{
try
        {
        Memo1->Lines->LoadFromFile(FILENAME_TIPS);
        }
catch(...)
        {
        MainForm->NTips->Visible=false;
        return;
        }

randomize();
iTip=random(Memo1->Lines->Count);
StaticText1->Caption=Memo1->Lines->Strings[iTip];
CheckBox1->Checked=MainForm->Prefs.bTips;
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::ButtonCloseClick(TObject *Sender)
{
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::CheckBox1Click(TObject *Sender)
{
MainForm->Prefs.bTips=CheckBox1->Checked;
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::FormShow(TObject *Sender)
{
iTip=random(Memo1->Lines->Count);
StaticText1->Caption=Memo1->Lines->Strings[iTip];
ShowNTipsInLabel(iTip);
CheckBox1->Checked=MainForm->Prefs.bTips;
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::ButtonDownClick(TObject *Sender)
{
if (iTip==0)      iTip=Memo1->Lines->Count-1;
else iTip--;
ShowNTipsInLabel(iTip);
StaticText1->Caption=Memo1->Lines->Strings[iTip];
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::ButtonUpClick(TObject *Sender)
{
if (iTip==Memo1->Lines->Count-1)      iTip=0;
else iTip++;
ShowNTipsInLabel(iTip);
StaticText1->Caption=Memo1->Lines->Strings[iTip];
}
//------------------------------------------------------------------------------
void TFormTips::ShowNTipsInLabel(int i)
{
AnsiString aAnsi="   ";
aAnsi+=i+1;
aAnsi+="/";
aAnsi+=Memo1->Lines->Count;
Label1->Caption=aAnsi;
}
//------------------------------------------------------------------------------
void __fastcall TFormTips::ButtonCloseKeyPress(TObject *Sender, char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------





