#include <vcl.h>
#pragma hdrstop

#include "Unit5.h"
#include "Main.h"
#include "Unit13.h"
#include "CSV.cpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormOldNames *FormOldNames;
TCSVBase OldCity=TCSVBase(FILENAME_OLD_CITY, 2);
int y=-1;
int yold=-1;
//------------------------------------------------------------------------------
__fastcall TFormOldNames::TFormOldNames(TComponent* Owner)
        : TForm(Owner)
{
if (OldCity.bError)
        {
        if (MainForm->bFormCityCodes) FormCityCodes->NOldNames->Enabled=false;
        return;
        }
else
        {
        OldCity.lpArrayScr[0]="";
        OldCity.lpArrayScr[1]="";
        int i=0;
        while (OldCity.Find(SEARCH_OLD_CITY))
                {
                StringGrid1->Cells[1][i]=OldCity.lpArrayDest[0];
                StringGrid1->Cells[2][i++]=OldCity.lpArrayDest[1];
                }
        }
StringGrid1->RowCount=OldCity.iAbonents;
MainForm->NumToStringGrid((void*)StringGrid1, OldCity.iAbonents);
StringGrid1->DoubleBuffered=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*)StringGrid1, true, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, false, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::FormShow(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }

if (ACol==0)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
               &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol)
        {
        DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
            &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        y=(StringGrid1->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid1->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::StringGrid1KeyPress(TObject *Sender,
      char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormOldNames::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int i;
for (i=0; HeaderControl->Sections->Count;i++)
        {
        if (HeaderControl->Sections->Items[i]==Section) break;
        }
if (!i) return;
OldCity.iDirectSort[i-1]*=-1;
MainForm->SortStringGrid((void*) StringGrid1, i, OldCity.iDirectSort[i-1]);
HeaderControl->Update();
}
//------------------------------------------------------------------------------

