#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit6.h"
#include "Main.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

#define  PUREBOOK 6
#define  FULLBOOK 7

TFormBook *FormBook;
//------------------------------------------------------------------------------
__fastcall TFormBook::TFormBook(TComponent* Owner)
        : TForm(Owner)
{
bChangeText=false;
char cBuffer[MAX_PATH];
GetWindowsDirectory(cBuffer, MAX_PATH);
aFileName=cBuffer;
aFileName+="\\";
aFileName+=FILENAME_BOOK;

static bool bStart=true;
if (bStart)
        {
        WindowState=wsMaximized;
        bStart=false;
        }

Memo1->SelectAll();
bool bError=false;

try
        {
        Memo1->Lines->LoadFromFile(aFileName.c_str());
        }
catch (...)
        {
        bError=true;
        }

if (!bError)
        {
        bChangeText=true;
        Memo1->Hint=" ";
        MainForm->ToolButtonBook->Hint=" ";
        MainForm->ToolButtonBook->ImageIndex=FULLBOOK;
        }

if (bError || !Memo1->Text.Length())
        {
        Memo1->Hint="  ";
        MainForm->ToolButtonBook->Hint="  ";
        MainForm->ToolButtonBook->ImageIndex=PUREBOOK;
        ToolButtonSave->Enabled=false;
        }
if (MainForm->bErrorToolBarBook)  ToolBar1->Visible=false;
MainForm->bFormBook=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonUndoClick(TObject *Sender)
{
Memo1->Undo();
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonCutClick(TObject *Sender)
{
Memo1->CutToClipboard();
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonCopyClick(TObject *Sender)
{
Memo1->CopyToClipboard();
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonPasteClick(TObject *Sender)
{
Memo1->PasteFromClipboard();
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormBook=false;
MainForm->ToolButtonBook->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::Memo1Change(TObject *Sender)
{
bChangeText=true;
if (Memo1->Text.Length())
 {
 Memo1->Hint=" ";
 MainForm->ToolButtonBook->ImageIndex=FULLBOOK;
 MainForm->ToolButtonBook->Hint=" ";
 ToolButtonSave->Enabled=true;
 }
else
 {
 Memo1->Hint="  ";
 MainForm->ToolButtonBook->Hint="  ";
 MainForm->ToolButtonBook->ImageIndex=PUREBOOK;
 ToolButtonSave->Enabled=false;
 }
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::FormDestroy(TObject *Sender)
{
if (bChangeText)    Memo1->Lines->SaveToFile(aFileName.c_str());
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonSelectAllClick(TObject *Sender)
{
Memo1->SelectAll();
}
//------------------------------------------------------------------------------

void __fastcall TFormBook::FormActivate(TObject *Sender)
{
MainForm->ToolButtonBook->Down=true;
MainForm->SeeTitle(FORM_BOOK);
}
//------------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonLoadClick(TObject *Sender)
{
ToolBar1->Refresh();
if (OpenDialog1->Execute())
        {
        Memo1->Lines->LoadFromFile(OpenDialog1->FileName);
        }

}
//---------------------------------------------------------------------------
void __fastcall TFormBook::ToolButtonSaveClick(TObject *Sender)
{
ToolBar1->Refresh();
if (SaveDialog1->Execute())
        {
        Memo1->Lines->SaveToFile(SaveDialog1->FileName);
        }

}
//---------------------------------------------------------------------------


