#ifndef Unit6H
#define Unit6H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//------------------------------------------------------------------------------
class TFormBook : public TForm
{
__published:	// IDE-managed Components
        TMemo *Memo1;
        TOpenDialog *OpenDialog1;
        TSaveDialog *SaveDialog1;
        TToolBar *ToolBar1;
        TToolButton *ToolButtonUndo;
        TToolButton *ToolButtonCut;
        TToolButton *ToolButtonCopy;
        TToolButton *ToolButtonPaste;
        TToolButton *ToolButtonSelectAll;
        TToolButton *ToolButtonSave;
        TToolButton *ToolButtonLoad;
        TToolButton *ToolButton5;
        void __fastcall ToolButtonUndoClick(TObject *Sender);
        void __fastcall ToolButtonCutClick(TObject *Sender);
        void __fastcall ToolButtonCopyClick(TObject *Sender);
        void __fastcall ToolButtonPasteClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Memo1Change(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ToolButtonSelectAllClick(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall ToolButtonLoadClick(TObject *Sender);
        void __fastcall ToolButtonSaveClick(TObject *Sender);
private:	// User declarations
public:
        __fastcall TFormBook(TComponent* Owner);
        AnsiString aFileName;
        bool bChangeText;
};
//------------------------------------------------------------------------------
extern PACKAGE TFormBook *FormBook;
//------------------------------------------------------------------------------
#endif
