#include <Tapi.h>
#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit1.h"
#include "Unit6.h"
#include "Unit7.h"
#include "Unit83.h"
#include "Unit19.h"
#include "CSV.cpp"
#include "Main.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

TFormOAOPhones *FormOAOPhones;
TCSVBase OAO=TCSVBase(FILENAME_PHONEOAO, 3);
TCSVBase KGRES=TCSVBase(FILENAME_PHONEOAOKGRES, 3);
TCSVBase VRTZ=TCSVBase(FILENAME_PHONEOAOVRTZ, 3);
TCSVBase CAT=TCSVBase(FILENAME_CATEGORIES, 32);

bool bCheckComboBox=false;
AnsiString aNumberPhone;
AnsiString aPhoneTextC;
int y=-1, yold=-1;
//------------------------------------------------------------------------------
void TFormOAOPhones::TypeCategorie()
{
if (RadioButton2->Checked || RadioButton3->Checked)
        {
        HeaderControl1->Sections->Items[2]->Text=", , ...";
        }
else
        {
        HeaderControl1->Sections->Items[2]->Text=", , ...";
        }

}
//------------------------------------------------------------------------------
__fastcall TFormOAOPhones::TFormOAOPhones(TComponent* Owner)
        : TForm(Owner)
{
bSearchMapOAO=false;
iRadioOAO=-1;
iRadioKGRES=-1;
iRadioVRTZ=-1;

int iNum=0;
char* cBuf;

MainForm->bOAO=false;
MainForm->bKGRES=false;
MainForm->bVRTZ=false;
MainForm->bRunOAOPhones=false;

RadioButton1->Enabled=false;
RadioButton2->Enabled=false;
RadioButton3->Enabled=false;
RadioButtonCategorie->Enabled=false;

if (!CAT.bError && !OAO.bError)
        {
        CAT.bNewFindTextForCombo=true;
        while((cBuf=CAT.FindTextForCombo()))
                {
                ComboBoxCategorie->Items->Add(cBuf);
                }
        RadioButtonCategorie->Enabled=true;
        }
if (!OAO.bError)
        {
        iNum++;
        MainForm->bOAO=true;
        OAO.bNewFindTextForCombo=true;
        while((cBuf=OAO.FindTextForCombo()))
                {
                ComboBoxOAO->Items->Add(cBuf);
                }
        RadioButton1->Enabled=true;
        }
if (!KGRES.bError)
        {
        iNum++;
        MainForm->bKGRES=true;
        KGRES.bNewFindTextForCombo=true;
        while((cBuf=KGRES.FindTextForCombo()))
                {
                ComboBoxKGRES->Items->Add(cBuf);
                }
        RadioButton2->Enabled=true;
        }
if (!VRTZ.bError)
        {
        iNum++;
        MainForm->bVRTZ=true;
        VRTZ.bNewFindTextForCombo=true;
        while((cBuf=VRTZ.FindTextForCombo()))
                {
                ComboBoxVRTZ->Items->Add(cBuf);
                }
        RadioButton3->Enabled=true;
        }

if (!iNum)
        {
        MainForm->ToolButtonOAOPhones->Visible=false;
        MainForm->NOAOPhones->Visible=false;
        Close();
        return;
        }

MainForm->bRunOAOPhones=true;

if (MainForm->Prefs.bSaveText)
        {
        ComboBoxPhone->Text=MainForm->Prefs.szOAOPhone;
        switch (MainForm->Prefs.iOAON)
                {
                case 1:
                        ComboBoxOAO->Text=MainForm->Prefs.szOAO;
                        if (!OAO.bError)        RadioButton1->Checked=true;
                        break;
                case 2:
                        ComboBoxKGRES->Text=MainForm->Prefs.szOAO;
                        if (!KGRES.bError)      RadioButton2->Checked=true;
                        break;
                case 3:
                        ComboBoxVRTZ->Text=MainForm->Prefs.szOAO;
                        if (!VRTZ.bError)       RadioButton3->Checked=true;
                        break;
                default:
                        ComboBoxCategorie->ItemIndex=MainForm->Prefs.iOAOCatN;
                        if (!CAT.bError)        RadioButtonCategorie->Checked=true;
                        break;

                }
        }

if (!RadioButton1->Checked && !RadioButton2->Checked && !RadioButton3->Checked && !RadioButtonCategorie->Checked)
        {
        if (!CAT.bError)
                {
                RadioButtonCategorie->Checked=true;
                }
        else
                {
                if (!OAO.bError)
                        {
                        RadioButton1->Checked=true;
                        }
                else
                        {
                        if (!KGRES.bError)
                                {
                                RadioButton1->Checked=true;
                                }
                        else
                                {
                                if (!KGRES.bError)
                                        {
                                        RadioButton1->Checked=true;
                                        }
                                }
                        }
                }
        }



if (RadioButton1->Checked)
        {
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;
        StringGrid2->Visible=false;
        StringGrid3->Visible=false;
        StringGrid4->Visible=false;

        ComboBoxOAO->Visible=true;
        ComboBoxVRTZ->Visible=false;
        ComboBoxKGRES->Visible=false;
        GroupBoxOAO->Caption=", :";
        }

if (RadioButton2->Checked)
        {
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;
        StringGrid1->Visible=false;
        StringGrid3->Visible=false;
        StringGrid4->Visible=false;

        ComboBoxOAO->Visible=false;
        ComboBoxKGRES->Visible=true;
        ComboBoxVRTZ->Visible=false;
        GroupBoxOAO->Caption=", :";
        }
if (RadioButton3->Checked)
        {
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;

        StringGrid1->Visible=false;
        StringGrid2->Visible=false;
        StringGrid4->Visible=false;

        ComboBoxOAO->Visible=false;
        ComboBoxKGRES->Visible=false;
        ComboBoxVRTZ->Visible=true;
        GroupBoxOAO->Caption=", :";
        }
if (RadioButtonCategorie->Checked)
        {
        GroupBoxCategorie->Visible=true;
        GroupBoxOAO->Visible=false;
        GroupBoxPhone->Visible=false;
        StringGrid1->Visible=false;
        StringGrid2->Visible=false;
        StringGrid3->Visible=false;
        }

try
        {
        Image1->Picture->LoadFromFile(FILENAME_PICTURE_MAN);
        }
catch(...)
        {
        ComboBoxOAO->Width+=WIDTH_PICTURE;
        ComboBoxOAO->Left-=WIDTH_PICTURE;
        ComboBoxKGRES->Width+=WIDTH_PICTURE;
        ComboBoxKGRES->Left-=WIDTH_PICTURE;
        ComboBoxVRTZ->Width+=WIDTH_PICTURE;
        ComboBoxVRTZ->Left-=WIDTH_PICTURE;
        }
try
        {
        Image2->Picture->LoadFromFile(FILENAME_PICTURE_PHONE);
        }
catch(...)
        {
        ComboBoxPhone->Width+=WIDTH_PICTURE;
        ComboBoxPhone->Left-=WIDTH_PICTURE;
        }

MainForm->bFormOAOPhones=true;

StringGrid1->DoubleBuffered=true;
StringGrid2->DoubleBuffered=true;
StringGrid3->DoubleBuffered=true;
StringGrid4->DoubleBuffered=true;

TypeCategorie();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::Button2Click(TObject *Sender)
{
StringGrid1->Visible=false;
StringGrid2->Visible=false;
StringGrid3->Visible=false;
StringGrid4->Visible=false;

if (RadioButton1->Checked)
        {
        StringGrid1->Visible=false;
        ComboBoxOAO->Text="";
        ComboBoxPhone->Text="";
        }
if (RadioButton2->Checked)
        {
        ComboBoxKGRES->Text="";
        ComboBoxPhone->Text="";
        }
if (RadioButton3->Checked)
        {
        ComboBoxVRTZ->Text="";
        ComboBoxPhone->Text="";
        }
if (RadioButtonCategorie->Checked)      ComboBoxCategorie->ItemIndex=0;

ButtonSearch->Enabled=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::NCopyClick(TObject *Sender)
{
TStringGrid* StringGrid;

if (RadioButton1->Checked)      StringGrid=StringGrid1;
if (RadioButton2->Checked)      StringGrid=StringGrid2;
if (RadioButton3->Checked)      StringGrid=StringGrid3;
if (RadioButtonCategorie->Checked)      StringGrid=StringGrid4;

MainForm->CopyAt((void*) StringGrid, true, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::PopupMenu1Popup(TObject *Sender)
{
AnsiString aPhoneText="   ";
aPhoneTextC="";
AnsiString aBuf="";
TStringGrid* StringGrid;

NCall->Enabled=true;

if (RadioButton1->Checked)      StringGrid=StringGrid1;
if (RadioButton2->Checked)      StringGrid=StringGrid2;
if (RadioButton3->Checked)      StringGrid=StringGrid3;
if (RadioButtonCategorie->Checked)      StringGrid=StringGrid4;

if (StringGrid->Visible)
        {
        aNumberPhone=(StringGrid->Cells[1][StringGrid->Selection.Top]).c_str();
        aNumberPhone.Delete(aNumberPhone.Pos(","),aNumberPhone.Length()-aNumberPhone.Pos(",")+1);
        aPhoneText+=aNumberPhone.c_str();
        aPhoneText+=" (";
        aBuf=StringGrid->Cells[2][StringGrid->Selection.Top];
        if (aBuf.Length()>8)
                {
                aBuf.SetLength(8);
                aPhoneTextC+=aBuf.c_str();
                aPhoneTextC+="... ";
                }
        else
                {
                aPhoneTextC+=aBuf.c_str();
                aPhoneTextC+=" ";
                }
        aBuf=StringGrid->Cells[3][StringGrid->Selection.Top];
        if (aBuf.Length()>8)
                {
                aBuf.SetLength(8);
                aPhoneTextC+=aBuf.c_str();
                aPhoneTextC+="... ";
                }
        else
                {
                aPhoneTextC+=" ";
                aPhoneTextC+=aBuf.c_str();
                }
        aPhoneText+=aPhoneTextC.c_str();
        aPhoneText+=")";
        NCall->Caption=aPhoneText;
        }
else
        {
        NCall->Caption="  ";
        }
AnsiString anAn1="#";
AnsiString anAn2="#";
anAn1+=StringGrid->Cells[2][StringGrid->Selection.Top];
anAn2+=StringGrid->Cells[3][StringGrid->Selection.Top];
if (MainForm->Prefs.iPerehodAtMap==2)
        {
        NSeeAtMap->Enabled=false;
        }
else
        {
        NSeeAtMap->Enabled=false;
        if (MainForm->ToolButtonMap->Visible)
                {
                if (!MainForm->bFormMap) Application->CreateForm(__classid(TFormMap), &FormMap);
                if (FormMap->FindNameOAO(NULL, anAn1) || FormMap->FindNameOAO(NULL, anAn2) || FormMap->FindNameOAO(NULL, StringGrid->Cells[2][StringGrid->Selection.Top]) || FormMap->FindNameOAO(NULL, StringGrid->Cells[3][StringGrid->Selection.Top]))       NSeeAtMap->Enabled=true;
                }
        }
if (RadioButton2->Checked || RadioButton3->Checked)     NSeeAtMap->Enabled=false;
if (!StringGrid->Visible)
        {
        NCopy->Enabled=false;
        NSeeAtMap->Enabled=false;
        NCall->Enabled=false;
        NAddInBook->Enabled=false;
        }
else
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }

}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::FormClose(TObject *Sender,
      TCloseAction &Action)
{
MainForm->bFormOAOPhones=false;
MainForm->ToolButtonOAOPhones->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::FormActivate(TObject *Sender)
{
MainForm->ToolButtonOAOPhones->Down=true;
MainForm->SeeTitle(FORM_OAO);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ComboBoxPhoneKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::NSeeAtMapClick(TObject *Sender)
{
if (MainForm->Prefs.iPerehodAtMap>=2) return;
AnsiString anAn1="#";
AnsiString anAn2="#";
TStringGrid* StringGrid;
StringGrid=StringGrid1;
if (RadioButtonCategorie->Checked)      StringGrid=StringGrid4;

anAn1+=StringGrid->Cells[2][StringGrid->Selection.Top];
anAn2+=StringGrid->Cells[3][StringGrid->Selection.Top];
if (!MainForm->ToolButtonMap->Visible)  return;
if (!MainForm->bFormMap) Application->CreateForm(__classid(TFormMap), &FormMap);
if (FormMap->FindNameOAO(FormPhoto->Image1, anAn1) || FormMap->FindNameOAO(FormPhoto->Image1, anAn2) || FormMap->FindNameOAO(FormPhoto->Image1, StringGrid->Cells[2][StringGrid->Selection.Top]) || FormMap->FindNameOAO(FormPhoto->Image1, StringGrid->Cells[3][StringGrid->Selection.Top]))
        {
        FormMap->Show();
        FormMap->ShowAtMap(CLOSE_HOTSPOT);
        MainForm->ShowAbonentAndMap(PHONES_ONLY_OAO);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ComboBoxVRTZChange(TObject *Sender)
{
if (!bCheckComboBox) ButtonSearch->Enabled=true;
bCheckComboBox=false;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ComboBox4Click(TObject *Sender)
{
ComboBoxPhone->Text="";
bCheckComboBox=true;
ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::NCallClick(TObject *Sender)
{
MainForm->CallDialer(aNumberPhone, aPhoneTextC);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::NAddInBookClick(TObject *Sender)
{
TStringGrid* StringGrid;
if (RadioButton1->Checked)      StringGrid=StringGrid1;
if (RadioButton2->Checked)      StringGrid=StringGrid2;
if (RadioButton3->Checked)      StringGrid=StringGrid3;
if (RadioButtonCategorie->Checked)      StringGrid=StringGrid4;

MainForm->CopyAt((void*) StringGrid, false, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid2, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid3, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid4, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid2, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid3, (void*) HeaderControl1);
MainForm->ResizeStringGrid((void*) StringGrid4, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (!ACol)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
               &Rect,DT_VCENTER|DT_SINGLELINE );
        }
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (ACol==1)
        {
        DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
        &Rect,DT_CENTER|DT_VCENTER|DT_SINGLELINE );
        }
else
        {
        if (ARow && ACol==2 && SG->Cells[ACol][ARow]==SG->Cells[ACol][ARow-1])
                {
                Cv->Font->Style = TFontStyles();
                }
        else if (ACol==2)
                Cv->Font->Style = TFontStyles()<< fsBold;
                DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
                           &Rect,DT_VCENTER|DT_SINGLELINE );
        }
}
//------------------------------------------------------------------------------
int TFormOAOPhones::SearchNameSavesOAO(char* cName)
{
int i=0;
char cNameBuf[MAX_LEN_STRING];
lstrcpy(cNameBuf, cName);
OAO.lpArrayScr[0]=cNameBuf;
OAO.lpArrayScr[1]=cNameBuf;
OAO.lpArrayScr[2]="";
OAO.lpArrayScr[3]="";
bool bFlag=false;

for (int l=0; cNameBuf[l]!=NULL; l++)
        {
        if (cNameBuf[l]=='|')
                {
                bFlag=true;
                break;
                }
        }

if (!OAO.bError)
        {
        if (bFlag)
                {
                for (int l=0; l<255; l++)
                        {
                        OAO.cMultiOAO[l]=NULL;
                        }
                int k=0;
                OAO.cMultiOAO[0]=cNameBuf;
                for (int l=0; l<MAX_LEN_STRING; l++)
                        {
                        if (cNameBuf[l]=='|')
                               {
                               k++;
                               OAO.cMultiOAO[k]=&cNameBuf[l+1];
                               cNameBuf[l]=NULL;
                               }
                        }
                 while (OAO.Find(SEARCH_MULTI_OAO))
                         {
                         i++;
                         }
                }
        else
                {
                while (OAO.Find(SEARCH_OAO))
                        {
                        i++;
                        }
                }
        }
return i;
}
//------------------------------------------------------------------------------
int TFormOAOPhones::SearchNumberSavesOAO(char* cPhone)
{
int i=0;
OAO.lpArrayScr[0]="";
OAO.lpArrayScr[1]="";
OAO.lpArrayScr[2]=cPhone;
OAO.lpArrayScr[3]="";
if (!OAO.bError)
        {
        while (OAO.Find(SEARCH_OAO))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
int TFormOAOPhones::SearchNumberSavesKGRES(char* cPhone)
{
int i=0;
KGRES.lpArrayScr[0]="";
KGRES.lpArrayScr[1]="";
KGRES.lpArrayScr[2]=cPhone;
KGRES.lpArrayScr[3]="";
if (!KGRES.bError)
        {
        while (KGRES.Find(SEARCH_KGRES))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
int TFormOAOPhones::SearchNumberSavesVRTZ(char* cPhone)
{
int i=0;
VRTZ.lpArrayScr[0]="";
VRTZ.lpArrayScr[1]="";
VRTZ.lpArrayScr[2]=cPhone;
VRTZ.lpArrayScr[3]="";
if (!VRTZ.bError)
        {
        while (VRTZ.Find(SEARCH_VRTZ))
                {
                i++;
                }
        }

return i;
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::StringGrid3MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
TStringGrid* StringGrid=(TStringGrid*) Sender;
y=(StringGrid->MouseCoord(X,Y)).Y;
if (y!=yold)
        {
        if (StringGrid==StringGrid1 || StringGrid==StringGrid4) 
        if (MainForm->bFormMap && MainForm->Prefs.bMoveMousePhoto && !MainForm->Prefs.bPhotoOff && MainForm->Prefs.bPhoto && y!=-1)
                {
                AnsiString anAn1=StringGrid->Cells[2][y];
                AnsiString anAn0=StringGrid->Cells[1][y];

                static AnsiString anAnOld3;
                bool bFlag=true;
                if (anAn1!=anAnOld3)
                        {
                        bFlag=FormMap->FindNameOAO(FormPhoto->Image1, anAn1);
                        anAnOld3=anAn1;
                        }
                if (anAn0!=anAnOld3 && !bFlag)
                        {
                        bFlag=FormMap->FindNameOAO(FormPhoto->Image1, anAn0);
                        anAnOld3=anAn0;
                        }
                }
        if (!MainForm->Prefs.bSelectionText)
                {
                StringGrid->Repaint();
                }
        else
                {
                y=-1;
                }
        }
yold=y;

}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ButtonSearchClick(TObject *Sender)
{
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
char cNameOAO[MAX_LEN_STRING];
char cPhone[MAX_LEN_STRING];
char cBuf[MAX_LEN_STRING];

ButtonSearch->Enabled=false;
TStringGrid* StringGrid=StringGrid1;
TCSVBase *CSV;
int iFlagSearch=SEARCH_OAO;

ComboBoxOAO->GetTextBuf(cNameOAO, MAX_LEN_STRING);
CSV=&OAO;

if (RadioButton1->Checked && ComboBoxOAO->Text.AnsiPos("|"))
        {
        for (int l=0; l<255; l++)
                {
                OAO.cMultiOAO[l]=NULL;
                }
        ComboBoxOAO->GetTextBuf(cBuf, MAX_LEN_STRING);
        int i=0;
        OAO.cMultiOAO[0]=cBuf;
        for (int l=0; l<MAX_LEN_STRING; l++)
                {
                        if (cBuf[l]=='|')
                                {
                                i++;
                                OAO.cMultiOAO[i]=&cBuf[l+1];
                                cBuf[l]=NULL;
                                }
                }
        iFlagSearch=SEARCH_MULTI_OAO;
        }
if (RadioButton2->Checked)
        {
        ComboBoxKGRES->GetTextBuf(cNameOAO, MAX_LEN_STRING);
        StringGrid=StringGrid2;
        CSV=&KGRES;
        iFlagSearch=SEARCH_KGRES;
        }
if (RadioButton3->Checked)
        {
        ComboBoxVRTZ->GetTextBuf(cNameOAO, MAX_LEN_STRING);
        StringGrid=StringGrid3;
        CSV=&VRTZ;
        iFlagSearch=SEARCH_VRTZ;
        }
if (RadioButtonCategorie->Checked)
        {
        ComboBoxCategorie->GetTextBuf(cNameOAO, MAX_LEN_STRING);
        StringGrid=StringGrid4;
        }

AnsiString aInput=ComboBoxPhone->Text.c_str();
if (RadioButton1->Checked)      ComboBoxPhone->GetTextBuf(cPhone, MAX_LEN_STRING);
if (RadioButton2->Checked)
        {
        if (aInput.Length())
                if (aInput[1]!='7' && aInput[1]=='2' && aInput.Length()<5)      aInput.Insert("7",1);
        lstrcpy(cPhone, aInput.c_str());
        }
if (RadioButton3->Checked)
        {
        if (aInput.Length())
                if (aInput[1]!='7' && (aInput[1]=='8' || aInput[1]=='9')&& aInput.Length()<5)   aInput.Insert("7",1);
        lstrcpy(cPhone, aInput.c_str());
        }

CSV->lpArrayScr[0]=cNameOAO;
CSV->lpArrayScr[2]=cPhone;
int i=0;
bool bStatus=false;
StringGrid->RowCount=CSV->iAbonents;
AnsiString anAnsiBuf;
if (!RadioButtonCategorie->Checked)
        {
        while (CSV->Find(iFlagSearch))
                {
                anAnsiBuf=CSV->lpArrayDest[2];
                if ((RadioButton2->Checked && MainForm->Prefs.iWhereComputer==1) || (RadioButton3->Checked && MainForm->Prefs.iWhereComputer==2))
                        {
                        if (anAnsiBuf.AnsiPos("7-")==1) anAnsiBuf.Delete(1,2);
                        for (int n=0; n<4; n++)
                                {
                                int k;
                                if ((k=anAnsiBuf.AnsiPos(", 7-"))>0)
                                        {
                                        anAnsiBuf.Delete(k+2, 2);
                                        }
                                        else
                                                {
                                                n=4;
                                                }
                                        }
                                }
                        StringGrid->Cells[1][i]=anAnsiBuf.c_str();
                        StringGrid->Cells[2][i]=CSV->lpArrayDest[0];
                        StringGrid->Cells[3][i]=CSV->lpArrayDest[1];
                        i++;
                }
        }
else
        {
        int l=-1;
        for (int j=0; CAT.iAbonents; j++)
                {
                if (!lstrcmp(CAT.lpArray[j][0], ComboBoxCategorie->Text.c_str()))
                        {
                        l=j;
                        break;
                        }
                }
        for (int n=0; n<OAO.iAbonents; n++)
                {
                if (!ComboBoxCategorie->ItemIndex)
                        {
                        StringGrid->Cells[1][i]=OAO.lpArray[n][2];
                        StringGrid->Cells[2][i]=OAO.lpArray[n][0];
                        StringGrid->Cells[3][i]=OAO.lpArray[n][1];
                        i++;
                        }
                else
                        for (int k=1; k<CAT.iColumn; k++)
                                {
                                if (*CAT.lpArray[l][k])
                                        if (OAO.FindInString(CAT.lpArray[l][k], OAO.lpArray[n][0]) || OAO.FindInString(CAT.lpArray[l][k], OAO.lpArray[n][1]))
                                                {
                                                StringGrid->Cells[1][i]=OAO.lpArray[n][2];
                                                StringGrid->Cells[2][i]=OAO.lpArray[n][0];
                                                StringGrid->Cells[3][i]=OAO.lpArray[n][1];
                                                i++;
                                                break;
                                                }
                                }
                }
        }
if (i)
        {
        StringGrid->RowCount=i;
        StringGrid->Visible=true;
        AnsiString aAnsi=": ";
        aAnsi+=i;
        aAnsi+="  ";
        aAnsi+=CSV->iAbonents;
        aAnsi+="  ()  ";
        DWORD dT2=GetTickCount();
        aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        aAnsi+=" .";
        StringGrid->Hint=aAnsi;
        MainForm->bNoMessageHelp=false;

        }
else
        {
        StringGrid->Visible=false;
        MainForm->MessageHelp(SPRAVKA_PHONES);
        MainForm->bNoMessageHelp=false;

        }
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int i;
for (i=0; HeaderControl->Sections->Count;i++)   if (HeaderControl->Sections->Items[i]==Section) break;
TStringGrid* StringGrid;
if (RadioButton1->Checked)      StringGrid=StringGrid1;
if (RadioButton2->Checked)      StringGrid=StringGrid2;
if (RadioButton3->Checked)      StringGrid=StringGrid3;
if (RadioButtonCategorie->Checked)      StringGrid=StringGrid4;

OAO.iDirectSort[i]*=-1;
MainForm->SortStringGrid((void*) StringGrid, i, OAO.iDirectSort[i]);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;        
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::RadioButton2Click(TObject *Sender)
{
static bool bStart=false;

//TRadioButton* Radio=(TRadioButton*) Sender;
//Radio->Checked=false;
//Radio->Update();

//Radio->Checked=true;
//SetFocus(Radio->Handle);

if (RadioButton1->Checked)
        {
        RadioButton2->Checked=false;
        RadioButton3->Checked=false;
        RadioButtonCategorie->Checked=false;

if (RadioButton1->CanFocus() && bStart && FormOAOPhones->Visible)   RadioButton1->SetFocus();
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;
        StringGrid2->Visible=false;
        StringGrid3->Visible=false;
        StringGrid4->Visible=false;

        ComboBoxOAO->Visible=true;
        ComboBoxVRTZ->Visible=false;
        ComboBoxKGRES->Visible=false;
        GroupBoxOAO->Caption=", :";
        if (MainForm->bFormMap && MainForm->Prefs.bPhoto && bStart)
                {
                AnsiString Ansi=DIRNAME_ADD_GFX;
                Ansi+="oao2.jpg";
                try
                        {
                        FormPhoto->Image1->Picture->LoadFromFile(Ansi);
                        FormPhoto->Image1->Visible=true;
                        }
                catch (...)
                        {
                        FormPhoto->Image1->Visible=false;
                        }
                }

        }

else if (RadioButton2->Checked)
        {
        RadioButton3->Checked=false;
        RadioButton1->Checked=false;
        RadioButtonCategorie->Checked=false;
if (RadioButton2->CanFocus()&& bStart && FormOAOPhones->Visible)   RadioButton2->SetFocus();
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;
        StringGrid1->Visible=false;
        StringGrid3->Visible=false;
        StringGrid4->Visible=false;

        ComboBoxOAO->Visible=false;
        ComboBoxKGRES->Visible=true;
        ComboBoxVRTZ->Visible=false;
        GroupBoxOAO->Caption=", :";
        if (MainForm->bFormMap && MainForm->Prefs.bPhoto && bStart)
                {
                AnsiString Ansi=DIRNAME_ADD_GFX;
                Ansi+="kgres.jpg";
                try
                        {
                        FormPhoto->Image1->Picture->LoadFromFile(Ansi);
                        FormPhoto->Image1->Visible=true;
                        }
                catch (...)
                        {
                        FormPhoto->Image1->Visible=false;
                        }
                }
        }
else if (RadioButton3->Checked)
        {
        RadioButton2->Checked=false;
        RadioButton1->Checked=false;
        RadioButtonCategorie->Checked=false;
if (RadioButton3->CanFocus()&& bStart && FormOAOPhones->Visible)   RadioButton3->SetFocus();
        GroupBoxCategorie->Visible=false;
        GroupBoxOAO->Visible=true;
        GroupBoxPhone->Visible=true;
        StringGrid1->Visible=false;
        StringGrid2->Visible=false;
        StringGrid4->Visible=false;
        ComboBoxOAO->Visible=false;
        ComboBoxKGRES->Visible=false;
        ComboBoxVRTZ->Visible=true;
        GroupBoxOAO->Caption=", :";
        if (MainForm->bFormMap && MainForm->Prefs.bPhoto && bStart)
                {
                AnsiString Ansi=DIRNAME_ADD_GFX;
                Ansi+="vrtz.jpg";
                try
                        {
                        FormPhoto->Image1->Picture->LoadFromFile(Ansi);
                        FormPhoto->Image1->Visible=true;
                        }
                catch (...)
                        {
                        FormPhoto->Image1->Visible=false;
                        }
                }
        }
else if (RadioButtonCategorie->Checked)
        {
        RadioButton2->Checked=false;
        RadioButton1->Checked=false;
        RadioButton3->Checked=false;
if (RadioButtonCategorie->CanFocus()&& bStart && FormOAOPhones->Visible)   RadioButtonCategorie->SetFocus();
        GroupBoxCategorie->Visible=true;
        GroupBoxOAO->Visible=false;
        GroupBoxPhone->Visible=false;
        StringGrid1->Visible=false;
        StringGrid2->Visible=false;
        StringGrid3->Visible=false;
        if (MainForm->bFormMap && MainForm->Prefs.bPhoto && bStart)
                {
                AnsiString Ansi=DIRNAME_ADD_GFX;
                Ansi+="oao1.jpg";
                try
                        {
                        FormPhoto->Image1->Picture->LoadFromFile(Ansi);
                        FormPhoto->Image1->Visible=true;
                        }
                catch (...)
                        {
                        FormPhoto->Image1->Visible=false;
                        }
                }

        }

ButtonSearch->Enabled=true;
TypeCategorie();
bStart=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ComboBoxCategorieChange(TObject *Sender)
{
ButtonSearch->Enabled=true;
ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::ComboBoxPhoneChange(TObject *Sender)
{
ButtonSearch->Enabled=true;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::StringGrid4Click(TObject *Sender)
{
TStringGrid* StringGrid=(TStringGrid*) Sender;
AnsiString anAn1=StringGrid->Cells[2][StringGrid->Selection.Top];
if (MainForm->bFormMap )     FormMap->FindNameOAO(FormPhoto->Image1, anAn1);
}
//------------------------------------------------------------------------------
void __fastcall TFormOAOPhones::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szOAOPhone, ComboBoxPhone->Text.c_str());
if (RadioButtonCategorie->Checked)
        {
        MainForm->Prefs.iOAON=0;
        MainForm->Prefs.iOAOCatN=ComboBoxCategorie->ItemIndex;
        }
if (RadioButton1->Checked)
        {
        lstrcpy(MainForm->Prefs.szOAO, ComboBoxOAO->Text.c_str());
        MainForm->Prefs.iOAON=1;
        }
if (RadioButton2->Checked)
        {
        lstrcpy(MainForm->Prefs.szOAO, ComboBoxKGRES->Text.c_str());
        MainForm->Prefs.iOAON=2;
        }
if (RadioButton3->Checked)
        {
        lstrcpy(MainForm->Prefs.szOAO, ComboBoxVRTZ->Text.c_str());
        MainForm->Prefs.iOAON=3;
        }
}
//------------------------------------------------------------------------------







